/* ViewWrapper.c generated by valac 0.48.17, the Vala compiler
 * generated from ViewWrapper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */
/*
 * Container and controller of the list and grid views, and info widgets
 * (welcome screen and embedded alert).
 *
 * A ViewWrapper triggers searches, status info updates, and also handles
 * view switching. It also works as a proxy for setting the media contained
 * by all the views. Please see set_media(), update_media(), remove_media()
 * and add_media().
 *
 * The views it contains implement the {@link Music.ContentView} interface.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <granite.h>
#include "io.elementary.music-core.h"
#include <handy.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define MUSIC_TYPE_VIEW_WRAPPER (music_view_wrapper_get_type ())
#define MUSIC_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper))
#define MUSIC_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))
#define MUSIC_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_WRAPPER))
#define MUSIC_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapperClass))

typedef struct _MusicViewWrapper MusicViewWrapper;
typedef struct _MusicViewWrapperClass MusicViewWrapperClass;
typedef struct _MusicViewWrapperPrivate MusicViewWrapperPrivate;

#define MUSIC_TYPE_LIST_VIEW (music_list_view_get_type ())
#define MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIST_VIEW, MusicListView))
#define MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))
#define MUSIC_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIST_VIEW))
#define MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIST_VIEW, MusicListViewClass))

typedef struct _MusicListView MusicListView;
typedef struct _MusicListViewClass MusicListViewClass;

#define MUSIC_TYPE_ALBUMS_VIEW (music_albums_view_get_type ())
#define MUSIC_ALBUMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsView))
#define MUSIC_ALBUMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsViewClass))
#define MUSIC_IS_ALBUMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_ALBUMS_VIEW))
#define MUSIC_IS_ALBUMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_ALBUMS_VIEW))
#define MUSIC_ALBUMS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_ALBUMS_VIEW, MusicAlbumsViewClass))

typedef struct _MusicAlbumsView MusicAlbumsView;
typedef struct _MusicAlbumsViewClass MusicAlbumsViewClass;
typedef enum  {
	MUSIC_VIEW_WRAPPER_HINT_NONE,
	MUSIC_VIEW_WRAPPER_HINT_MUSIC,
	MUSIC_VIEW_WRAPPER_HINT_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	MUSIC_VIEW_WRAPPER_HINT_CDROM,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST,
	MUSIC_VIEW_WRAPPER_HINT_QUEUE
} MusicViewWrapperHint;

#define MUSIC_VIEW_WRAPPER_TYPE_HINT (music_view_wrapper_hint_get_type ())

#define MUSIC_TYPE_VIEW_STACK (music_view_stack_get_type ())
#define MUSIC_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_STACK, MusicViewStack))
#define MUSIC_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_VIEW_STACK, MusicViewStackClass))
#define MUSIC_IS_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_STACK))
#define MUSIC_IS_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_VIEW_STACK))
#define MUSIC_VIEW_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_VIEW_STACK, MusicViewStackClass))

typedef struct _MusicViewStack MusicViewStack;
typedef struct _MusicViewStackClass MusicViewStackClass;
typedef enum  {
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID = 0,
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST = 1,
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT = 2,
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME = 3,
	MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE = 4
} MusicViewWrapperViewType;

#define MUSIC_VIEW_WRAPPER_TYPE_VIEW_TYPE (music_view_wrapper_view_type_get_type ())
enum  {
	MUSIC_VIEW_WRAPPER_0_PROPERTY,
	MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY,
	MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY,
	MUSIC_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY,
	MUSIC_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY,
	MUSIC_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY,
	MUSIC_VIEW_WRAPPER_HINT_PROPERTY,
	MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY,
	MUSIC_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY,
	MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY,
	MUSIC_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY,
	MUSIC_VIEW_WRAPPER_NUM_PROPERTIES
};
static GParamSpec* music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_TYPE_GENERIC_LIST (music_generic_list_get_type ())
#define MUSIC_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericList))
#define MUSIC_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))
#define MUSIC_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_GENERIC_LIST))
#define MUSIC_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_GENERIC_LIST, MusicGenericListClass))

typedef struct _MusicGenericList MusicGenericList;
typedef struct _MusicGenericListClass MusicGenericListClass;

#define MUSIC_TYPE_MUSIC_LIST_VIEW (music_music_list_view_get_type ())
#define MUSIC_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListView))
#define MUSIC_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))
#define MUSIC_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_MUSIC_LIST_VIEW))
#define MUSIC_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_MUSIC_LIST_VIEW, MusicMusicListViewClass))

typedef struct _MusicMusicListView MusicMusicListView;
typedef struct _MusicMusicListViewClass MusicMusicListViewClass;

#define MUSIC_TYPE_LIBRARY_WINDOW (music_library_window_get_type ())
#define MUSIC_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindow))
#define MUSIC_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))
#define MUSIC_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_LIBRARY_WINDOW))
#define MUSIC_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_LIBRARY_WINDOW, MusicLibraryWindowClass))

typedef struct _MusicLibraryWindow MusicLibraryWindow;
typedef struct _MusicLibraryWindowClass MusicLibraryWindowClass;

#define MUSIC_WIDGETS_TYPE_VIEW_SELECTOR (music_widgets_view_selector_get_type ())
#define MUSIC_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelector))
#define MUSIC_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelectorClass))
#define MUSIC_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR))
#define MUSIC_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR))
#define MUSIC_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_WIDGETS_TYPE_VIEW_SELECTOR, MusicWidgetsViewSelectorClass))

typedef struct _MusicWidgetsViewSelector MusicWidgetsViewSelector;
typedef struct _MusicWidgetsViewSelectorClass MusicWidgetsViewSelectorClass;

#define MUSIC_TYPE_COLUMN_BROWSER (music_column_browser_get_type ())
#define MUSIC_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowser))
#define MUSIC_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowserClass))
#define MUSIC_IS_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_COLUMN_BROWSER))
#define MUSIC_IS_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_COLUMN_BROWSER))
#define MUSIC_COLUMN_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_COLUMN_BROWSER, MusicColumnBrowserClass))

typedef struct _MusicColumnBrowser MusicColumnBrowser;
typedef struct _MusicColumnBrowserClass MusicColumnBrowserClass;
typedef enum  {
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_GRID = 0,
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_LIST = 1,
	MUSIC_WIDGETS_VIEW_SELECTOR_MODE_COLUMN = 2
} MusicWidgetsViewSelectorMode;

#define MUSIC_WIDGETS_VIEW_SELECTOR_TYPE_MODE (music_widgets_view_selector_mode_get_type ())

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;

#define MUSIC_TYPE_VIEW_INTERFACE (music_view_interface_get_type ())
#define MUSIC_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_VIEW_INTERFACE, MusicViewInterface))
#define MUSIC_IS_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_VIEW_INTERFACE))
#define MUSIC_VIEW_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), MUSIC_TYPE_VIEW_INTERFACE, MusicViewInterfaceIface))

typedef struct _MusicViewInterface MusicViewInterface;
typedef struct _MusicViewInterfaceIface MusicViewInterfaceIface;
typedef struct _MusicViewWrapperSetMediaAsyncData MusicViewWrapperSetMediaAsyncData;
typedef struct _MusicViewWrapperAddMediaAsyncData MusicViewWrapperAddMediaAsyncData;
typedef struct _MusicViewWrapperRemoveMediaAsyncData MusicViewWrapperRemoveMediaAsyncData;
typedef struct _MusicViewWrapperUpdateMediaAsyncData MusicViewWrapperUpdateMediaAsyncData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MusicViewWrapper {
	GtkGrid parent_instance;
	MusicViewWrapperPrivate * priv;
};

struct _MusicViewWrapperClass {
	GtkGridClass parent_class;
	gboolean (*check_have_media) (MusicViewWrapper* self);
	void (*select_proper_content_view) (MusicViewWrapper* self);
	void (*set_no_media_alert) (MusicViewWrapper* self);
};

struct _MusicViewWrapperPrivate {
	MusicListView* _list_view;
	MusicAlbumsView* _grid_view;
	GraniteWidgetsAlertView* _embedded_alert;
	GraniteWidgetsWelcome* _welcome_screen;
	MusicViewWrapperHint _hint;
	MusicLibrary* _library;
	MusicPlaylist* _playlist;
	gboolean widgets_ready;
	MusicViewStack* view_stack;
	MusicViewWrapperViewType last_used_view;
	gboolean data_initialized;
	GRecMutex __lock_list_view;
	GRecMutex __lock_grid_view;
};

struct _MusicViewInterfaceIface {
	GTypeInterface parent_iface;
	GeeCollection* (*get_media) (MusicViewInterface* self);
	GeeCollection* (*get_visible_media) (MusicViewInterface* self);
	void (*refilter) (MusicViewInterface* self);
	void (*set_media) (MusicViewInterface* self, GeeCollection* new_media);
	void (*add_media) (MusicViewInterface* self, GeeCollection* to_add);
	void (*remove_media) (MusicViewInterface* self, GeeCollection* to_remove);
	void (*update_media) (MusicViewInterface* self, GeeCollection* to_update);
};

struct _MusicViewWrapperSetMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicViewWrapper* self;
	GeeCollection* new_media;
};

struct _MusicViewWrapperAddMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicViewWrapper* self;
	GeeCollection* to_add;
};

struct _MusicViewWrapperRemoveMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicViewWrapper* self;
	GeeCollection* to_remove;
};

struct _MusicViewWrapperUpdateMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicViewWrapper* self;
	GeeCollection* to_update;
};

static gint MusicViewWrapper_private_offset;
static gpointer music_view_wrapper_parent_class = NULL;

GType music_view_wrapper_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewWrapper, g_object_unref)
GType music_list_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicListView, g_object_unref)
GType music_albums_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicAlbumsView, g_object_unref)
GType music_view_wrapper_hint_get_type (void) G_GNUC_CONST;
GType music_view_stack_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicViewStack, g_object_unref)
GType music_view_wrapper_view_type_get_type (void) G_GNUC_CONST;
gboolean music_view_wrapper_check_have_media (MusicViewWrapper* self);
void music_view_wrapper_select_proper_content_view (MusicViewWrapper* self);
void music_view_wrapper_set_no_media_alert (MusicViewWrapper* self);
#define MUSIC_VIEW_WRAPPER_VIEW_CONSTRUCT_PRIORITY (G_PRIORITY_DEFAULT_IDLE - 10)
MusicViewWrapper* music_view_wrapper_construct (GType object_type,
                                                MusicViewWrapperHint hint,
                                                MusicLibrary* library);
void music_view_wrapper_pack_views (MusicViewWrapper* self);
gboolean music_view_wrapper_get_has_grid_view (MusicViewWrapper* self);
MusicAlbumsView* music_view_wrapper_get_grid_view (MusicViewWrapper* self);
void music_view_stack_add_view (MusicViewStack* self,
                                GtkWidget* view);
gboolean music_view_wrapper_get_has_list_view (MusicViewWrapper* self);
MusicListView* music_view_wrapper_get_list_view (MusicViewWrapper* self);
gboolean music_view_wrapper_get_has_welcome_screen (MusicViewWrapper* self);
GraniteWidgetsWelcome* music_view_wrapper_get_welcome_screen (MusicViewWrapper* self);
gboolean music_view_wrapper_get_has_embedded_alert (MusicViewWrapper* self);
GraniteWidgetsAlertView* music_view_wrapper_get_embedded_alert (MusicViewWrapper* self);
void music_view_wrapper_set_active_view (MusicViewWrapper* self,
                                         MusicViewWrapperViewType type,
                                         gboolean* successful);
MusicViewWrapperViewType music_view_wrapper_get_current_view (MusicViewWrapper* self);
gboolean music_view_wrapper_get_is_current_wrapper (MusicViewWrapper* self);
GType music_generic_list_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicGenericList, g_object_unref)
GType music_music_list_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicMusicListView, g_object_unref)
MusicMusicListView* music_list_view_get_list_view (MusicListView* self);
void music_generic_list_scroll_to_current_media (MusicGenericList* self,
                                                 gboolean unfilter_if_not_found);
MusicViewWrapperHint music_view_wrapper_get_hint (MusicViewWrapper* self);
void music_view_wrapper_update_library_window_widgets (MusicViewWrapper* self);
GType music_library_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicLibraryWindow, g_object_unref)
MusicLibraryWindow* music_app_get_main_window (void);
gboolean music_library_window_get_initialization_finished (MusicLibraryWindow* self);
GtkSearchEntry* music_library_window_get_search_entry (MusicLibraryWindow* self);
gint music_view_wrapper_get_media_count (MusicViewWrapper* self);
GType music_widgets_view_selector_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicWidgetsViewSelector, g_object_unref)
MusicWidgetsViewSelector* music_library_window_get_view_selector (MusicLibraryWindow* self);
void music_widgets_view_selector_set_sensitive (MusicWidgetsViewSelector* self,
                                                gboolean value);
GType music_column_browser_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicColumnBrowser, g_object_unref)
MusicColumnBrowser* music_list_view_get_column_browser (MusicListView* self);
void music_widgets_view_selector_set_column_browser_toggle_active (MusicWidgetsViewSelector* self,
                                                                   gboolean active);
gboolean music_widgets_view_selector_get_column_browser_toggle_active (MusicWidgetsViewSelector* self);
GType music_widgets_view_selector_mode_get_type (void) G_GNUC_CONST;
MusicWidgetsViewSelectorMode music_widgets_view_selector_get_selected (MusicWidgetsViewSelector* self);
void music_widgets_view_selector_set_selected (MusicWidgetsViewSelector* self,
                                               MusicWidgetsViewSelectorMode value);
void music_view_wrapper_view_selector_changed (MusicViewWrapper* self);
gboolean music_widgets_view_selector_get_sensitive (MusicWidgetsViewSelector* self);
void music_view_wrapper_play_first_media (MusicViewWrapper* self,
                                          gboolean* force);
void music_list_view_set_as_current_list (MusicListView* self,
                                          gint media_id);
GType music_playback_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
MusicPlaybackManager* music_app_get_player (void);
MusicMedia* music_playback_manager_media_from_current_index (MusicPlaybackManager* self,
                                                             gint index_in_current);
void music_playback_manager_play_media (MusicPlaybackManager* self,
                                        MusicMedia* m);
void music_playback_manager_start_playback (MusicPlaybackManager* self);
void music_view_wrapper_set_as_current_view (MusicViewWrapper* self);
void music_view_wrapper_update_visible_media (MusicViewWrapper* self);
static void music_view_wrapper_search_field_changed (MusicViewWrapper* self);
static gboolean music_view_wrapper_real_check_have_media (MusicViewWrapper* self);
static void music_view_wrapper_real_select_proper_content_view (MusicViewWrapper* self);
GeeCollection* music_view_wrapper_get_media_list (MusicViewWrapper* self);
GType music_view_interface_get_type (void) G_GNUC_CONST;
GeeCollection* music_view_interface_get_media (MusicViewInterface* self);
void music_view_wrapper_clear_filters (MusicViewWrapper* self);
void music_view_interface_refilter (MusicViewInterface* self);
static void music_view_wrapper_real_set_no_media_alert (MusicViewWrapper* self);
static void music_view_wrapper_set_media_async_data_free (gpointer _data);
void music_view_wrapper_set_media_async (MusicViewWrapper* self,
                                         GeeCollection* new_media,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void music_view_wrapper_set_media_finish (MusicViewWrapper* self,
                                          GAsyncResult* _res_);
static gboolean music_view_wrapper_set_media_async_co (MusicViewWrapperSetMediaAsyncData* _data_);
static void music_view_wrapper_set_media (MusicViewWrapper* self,
                                   GeeCollection* new_media);
static void music_view_wrapper_add_media_async_data_free (gpointer _data);
void music_view_wrapper_add_media_async (MusicViewWrapper* self,
                                         GeeCollection* to_add,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void music_view_wrapper_add_media_finish (MusicViewWrapper* self,
                                          GAsyncResult* _res_);
static gboolean music_view_wrapper_add_media_async_co (MusicViewWrapperAddMediaAsyncData* _data_);
static void music_view_wrapper_add_media (MusicViewWrapper* self,
                                   GeeCollection* new_media);
static void music_view_wrapper_remove_media_async_data_free (gpointer _data);
void music_view_wrapper_remove_media_async (MusicViewWrapper* self,
                                            GeeCollection* to_remove,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
void music_view_wrapper_remove_media_finish (MusicViewWrapper* self,
                                             GAsyncResult* _res_);
static gboolean music_view_wrapper_remove_media_async_co (MusicViewWrapperRemoveMediaAsyncData* _data_);
static void music_view_wrapper_remove_media (MusicViewWrapper* self,
                                      GeeCollection* media);
static void music_view_wrapper_update_media_async_data_free (gpointer _data);
void music_view_wrapper_update_media_async (MusicViewWrapper* self,
                                            GeeCollection* to_update,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
void music_view_wrapper_update_media_finish (MusicViewWrapper* self,
                                             GAsyncResult* _res_);
static gboolean music_view_wrapper_update_media_async_co (MusicViewWrapperUpdateMediaAsyncData* _data_);
static void music_view_wrapper_update_media (MusicViewWrapper* self,
                                      GeeCollection* media);
void music_view_interface_set_media (MusicViewInterface* self,
                                     GeeCollection* new_media);
static void music_view_wrapper_update_widget_state (MusicViewWrapper* self);
void music_view_interface_update_media (MusicViewInterface* self,
                                        GeeCollection* to_update);
void music_view_interface_add_media (MusicViewInterface* self,
                                     GeeCollection* to_add);
void music_view_interface_remove_media (MusicViewInterface* self,
                                        GeeCollection* to_remove);
void music_view_wrapper_set_list_view (MusicViewWrapper* self,
                                       MusicListView* value);
void music_view_wrapper_set_grid_view (MusicViewWrapper* self,
                                       MusicAlbumsView* value);
void music_view_wrapper_set_embedded_alert (MusicViewWrapper* self,
                                            GraniteWidgetsAlertView* value);
void music_view_wrapper_set_welcome_screen (MusicViewWrapper* self,
                                            GraniteWidgetsWelcome* value);
void music_view_wrapper_set_hint (MusicViewWrapper* self,
                                  MusicViewWrapperHint value);
MusicLibrary* music_view_wrapper_get_library (MusicViewWrapper* self);
void music_view_wrapper_set_library (MusicViewWrapper* self,
                                     MusicLibrary* value);
MusicViewStack* music_library_window_get_view_stack (MusicLibraryWindow* self);
MusicPlaylist* music_view_wrapper_get_playlist (MusicViewWrapper* self);
void music_view_wrapper_set_playlist (MusicViewWrapper* self,
                                      MusicPlaylist* value);
guint music_list_view_get_n_media (MusicListView* self);
static GObject * music_view_wrapper_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
MusicViewStack* music_view_stack_new (void);
MusicViewStack* music_view_stack_construct (GType object_type);
static void _music_view_wrapper_view_selector_changed_music_widgets_view_selector_mode_changed (MusicWidgetsViewSelector* _sender,
                                                                                         MusicWidgetsViewSelectorMode new_mode,
                                                                                         gpointer self);
static void _music_view_wrapper_search_field_changed_music_library_search_finished (MusicLibrary* _sender,
                                                                             gpointer self);
static void music_view_wrapper_finalize (GObject * obj);
static GType music_view_wrapper_get_type_once (void);
static void _vala_music_view_wrapper_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_music_view_wrapper_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
music_view_wrapper_get_instance_private (MusicViewWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, MusicViewWrapper_private_offset);
}

static GType
music_view_wrapper_hint_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_VIEW_WRAPPER_HINT_NONE, "MUSIC_VIEW_WRAPPER_HINT_NONE", "none"}, {MUSIC_VIEW_WRAPPER_HINT_MUSIC, "MUSIC_VIEW_WRAPPER_HINT_MUSIC", "music"}, {MUSIC_VIEW_WRAPPER_HINT_PLAYLIST, "MUSIC_VIEW_WRAPPER_HINT_PLAYLIST", "playlist"}, {MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST, "MUSIC_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST", "read-only-playlist"}, {MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST, "MUSIC_VIEW_WRAPPER_HINT_SMART_PLAYLIST", "smart-playlist"}, {MUSIC_VIEW_WRAPPER_HINT_CDROM, "MUSIC_VIEW_WRAPPER_HINT_CDROM", "cdrom"}, {MUSIC_VIEW_WRAPPER_HINT_DEVICE, "MUSIC_VIEW_WRAPPER_HINT_DEVICE", "device"}, {MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO, "MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIO", "device-audio"}, {MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST, "MUSIC_VIEW_WRAPPER_HINT_DEVICE_PODCAST", "device-podcast"}, {MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK, "MUSIC_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK", "device-audiobook"}, {MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE, "MUSIC_VIEW_WRAPPER_HINT_NETWORK_DEVICE", "network-device"}, {MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST, "MUSIC_VIEW_WRAPPER_HINT_ALBUM_LIST", "album-list"}, {MUSIC_VIEW_WRAPPER_HINT_QUEUE, "MUSIC_VIEW_WRAPPER_HINT_QUEUE", "queue"}, {0, NULL, NULL}};
	GType music_view_wrapper_hint_type_id;
	music_view_wrapper_hint_type_id = g_enum_register_static ("MusicViewWrapperHint", values);
	return music_view_wrapper_hint_type_id;
}

GType
music_view_wrapper_hint_get_type (void)
{
	static volatile gsize music_view_wrapper_hint_type_id__volatile = 0;
	if (g_once_init_enter (&music_view_wrapper_hint_type_id__volatile)) {
		GType music_view_wrapper_hint_type_id;
		music_view_wrapper_hint_type_id = music_view_wrapper_hint_get_type_once ();
		g_once_init_leave (&music_view_wrapper_hint_type_id__volatile, music_view_wrapper_hint_type_id);
	}
	return music_view_wrapper_hint_type_id__volatile;
}

/**
     * Type of visual representation of the media.
     *
     * Values *must* match the index of the respective view in the view selector.
     */
static GType
music_view_wrapper_view_type_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID", "grid"}, {MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST", "list"}, {MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT", "alert"}, {MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME", "welcome"}, {MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE, "MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE", "none"}, {0, NULL, NULL}};
	GType music_view_wrapper_view_type_type_id;
	music_view_wrapper_view_type_type_id = g_enum_register_static ("MusicViewWrapperViewType", values);
	return music_view_wrapper_view_type_type_id;
}

GType
music_view_wrapper_view_type_get_type (void)
{
	static volatile gsize music_view_wrapper_view_type_type_id__volatile = 0;
	if (g_once_init_enter (&music_view_wrapper_view_type_type_id__volatile)) {
		GType music_view_wrapper_view_type_type_id;
		music_view_wrapper_view_type_type_id = music_view_wrapper_view_type_get_type_once ();
		g_once_init_leave (&music_view_wrapper_view_type_type_id__volatile, music_view_wrapper_view_type_type_id);
	}
	return music_view_wrapper_view_type_type_id__volatile;
}

MusicViewWrapper*
music_view_wrapper_construct (GType object_type,
                              MusicViewWrapperHint hint,
                              MusicLibrary* library)
{
	MusicViewWrapper * self = NULL;
	g_return_val_if_fail (library != NULL, NULL);
	self = (MusicViewWrapper*) g_object_new (object_type, "hint", hint, "library", library, NULL);
	return self;
}

/**
     * Checks which views are available and packs them in (if they are not packed yet)
     */
void
music_view_wrapper_pack_views (MusicViewWrapper* self)
{
	MusicViewStack* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_;
	gboolean _tmp30_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->view_stack;
	_vala_assert (_tmp0_ != NULL, "view_stack != null");
	_tmp2_ = music_view_wrapper_get_has_grid_view (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		MusicAlbumsView* _tmp4_;
		GtkContainer* _tmp5_;
		GtkContainer* _tmp6_;
		MusicViewStack* _tmp7_;
		_tmp4_ = self->priv->_grid_view;
		_tmp5_ = gtk_widget_get_parent ((GtkWidget*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = self->priv->view_stack;
		_tmp1_ = _tmp6_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_container_get_type (), GtkContainer);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		MusicViewStack* _tmp8_;
		MusicAlbumsView* _tmp9_;
		_tmp8_ = self->priv->view_stack;
		_tmp9_ = self->priv->_grid_view;
		music_view_stack_add_view (_tmp8_, (GtkWidget*) _tmp9_);
	}
	_tmp11_ = music_view_wrapper_get_has_list_view (self);
	_tmp12_ = _tmp11_;
	if (_tmp12_) {
		MusicListView* _tmp13_;
		GtkContainer* _tmp14_;
		GtkContainer* _tmp15_;
		MusicViewStack* _tmp16_;
		_tmp13_ = self->priv->_list_view;
		_tmp14_ = gtk_widget_get_parent ((GtkWidget*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = self->priv->view_stack;
		_tmp10_ = _tmp15_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_container_get_type (), GtkContainer);
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		MusicViewStack* _tmp17_;
		MusicListView* _tmp18_;
		_tmp17_ = self->priv->view_stack;
		_tmp18_ = self->priv->_list_view;
		music_view_stack_add_view (_tmp17_, (GtkWidget*) _tmp18_);
	}
	_tmp20_ = music_view_wrapper_get_has_welcome_screen (self);
	_tmp21_ = _tmp20_;
	if (_tmp21_) {
		GraniteWidgetsWelcome* _tmp22_;
		GtkContainer* _tmp23_;
		GtkContainer* _tmp24_;
		MusicViewStack* _tmp25_;
		_tmp22_ = self->priv->_welcome_screen;
		_tmp23_ = gtk_widget_get_parent ((GtkWidget*) _tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = self->priv->view_stack;
		_tmp19_ = _tmp24_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_container_get_type (), GtkContainer);
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		MusicViewStack* _tmp26_;
		GraniteWidgetsWelcome* _tmp27_;
		_tmp26_ = self->priv->view_stack;
		_tmp27_ = self->priv->_welcome_screen;
		music_view_stack_add_view (_tmp26_, (GtkWidget*) _tmp27_);
	}
	_tmp29_ = music_view_wrapper_get_has_embedded_alert (self);
	_tmp30_ = _tmp29_;
	if (_tmp30_) {
		GraniteWidgetsAlertView* _tmp31_;
		GtkContainer* _tmp32_;
		GtkContainer* _tmp33_;
		MusicViewStack* _tmp34_;
		_tmp31_ = self->priv->_embedded_alert;
		_tmp32_ = gtk_widget_get_parent ((GtkWidget*) _tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = self->priv->view_stack;
		_tmp28_ = _tmp33_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_container_get_type (), GtkContainer);
	} else {
		_tmp28_ = FALSE;
	}
	if (_tmp28_) {
		MusicViewStack* _tmp35_;
		GraniteWidgetsAlertView* _tmp36_;
		_tmp35_ = self->priv->view_stack;
		_tmp36_ = self->priv->_embedded_alert;
		music_view_stack_add_view (_tmp35_, (GtkWidget*) _tmp36_);
	}
	self->priv->widgets_ready = TRUE;
	gtk_widget_show_all ((GtkWidget*) self);
}

/**
     * Convenient visibility method
     */
void
music_view_wrapper_set_active_view (MusicViewWrapper* self,
                                    MusicViewWrapperViewType type,
                                    gboolean* successful)
{
	gboolean _vala_successful = FALSE;
	gboolean _tmp0_ = FALSE;
	MusicViewWrapperViewType _tmp1_;
	MusicViewWrapperViewType _tmp2_;
	g_return_if_fail (self != NULL);
	_vala_successful = TRUE;
	_tmp1_ = music_view_wrapper_get_current_view (self);
	_tmp2_ = _tmp1_;
	if (type == _tmp2_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp3_ = music_view_wrapper_get_is_current_wrapper (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = !_tmp4_;
	}
	if (_tmp0_) {
		if (successful) {
			*successful = _vala_successful;
		}
		return;
	}
	switch (type) {
		case MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST:
		{
			gboolean _tmp5_;
			gboolean _tmp6_;
			_tmp5_ = music_view_wrapper_get_has_list_view (self);
			_tmp6_ = _tmp5_;
			if (_tmp6_) {
				MusicViewStack* _tmp7_;
				MusicListView* _tmp8_;
				MusicListView* _tmp9_;
				MusicMusicListView* _tmp10_;
				MusicMusicListView* _tmp11_;
				_tmp7_ = self->priv->view_stack;
				_tmp8_ = self->priv->_list_view;
				gtk_stack_set_visible_child ((GtkStack*) _tmp7_, (GtkWidget*) _tmp8_);
				_tmp9_ = self->priv->_list_view;
				_tmp10_ = music_list_view_get_list_view (_tmp9_);
				_tmp11_ = _tmp10_;
				music_generic_list_scroll_to_current_media ((MusicGenericList*) _tmp11_, TRUE);
			} else {
				_vala_successful = FALSE;
			}
			break;
		}
		case MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID:
		{
			gboolean _tmp12_;
			gboolean _tmp13_;
			_tmp12_ = music_view_wrapper_get_has_grid_view (self);
			_tmp13_ = _tmp12_;
			if (_tmp13_) {
				MusicViewStack* _tmp14_;
				MusicAlbumsView* _tmp15_;
				_tmp14_ = self->priv->view_stack;
				_tmp15_ = self->priv->_grid_view;
				gtk_stack_set_visible_child ((GtkStack*) _tmp14_, (GtkWidget*) _tmp15_);
			} else {
				gboolean _tmp16_;
				gboolean _tmp17_;
				_tmp16_ = music_view_wrapper_get_has_list_view (self);
				_tmp17_ = _tmp16_;
				if (_tmp17_) {
					MusicViewStack* _tmp18_;
					MusicListView* _tmp19_;
					MusicListView* _tmp20_;
					MusicMusicListView* _tmp21_;
					MusicMusicListView* _tmp22_;
					_tmp18_ = self->priv->view_stack;
					_tmp19_ = self->priv->_list_view;
					gtk_stack_set_visible_child ((GtkStack*) _tmp18_, (GtkWidget*) _tmp19_);
					_tmp20_ = self->priv->_list_view;
					_tmp21_ = music_list_view_get_list_view (_tmp20_);
					_tmp22_ = _tmp21_;
					music_generic_list_scroll_to_current_media ((MusicGenericList*) _tmp22_, TRUE);
				}
				_vala_successful = FALSE;
			}
			break;
		}
		case MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT:
		{
			MusicViewStack* _tmp23_;
			GraniteWidgetsAlertView* _tmp24_;
			_tmp23_ = self->priv->view_stack;
			_tmp24_ = self->priv->_embedded_alert;
			gtk_stack_set_visible_child ((GtkStack*) _tmp23_, (GtkWidget*) _tmp24_);
			break;
		}
		case MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME:
		{
			MusicViewStack* _tmp25_;
			GraniteWidgetsWelcome* _tmp26_;
			_tmp25_ = self->priv->view_stack;
			_tmp26_ = self->priv->_welcome_screen;
			gtk_stack_set_visible_child ((GtkStack*) _tmp25_, (GtkWidget*) _tmp26_);
			break;
		}
		default:
		break;
	}
	if (!_vala_successful) {
		MusicViewWrapperHint _tmp27_;
		GEnumValue* _tmp28_;
		GEnumValue* _tmp29_;
		_tmp27_ = self->priv->_hint;
		_tmp28_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp27_);
		_tmp29_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_VIEW_TYPE), type);
		g_debug ("ViewWrapper.vala:208: %s : VIEW %s was not available", (_tmp28_ != NULL) ? _tmp28_->value_name : NULL, (_tmp29_ != NULL) ? _tmp29_->value_name : NULL);
		if (successful) {
			*successful = _vala_successful;
		}
		return;
	}
	self->priv->last_used_view = type;
	music_view_wrapper_update_library_window_widgets (self);
	if (successful) {
		*successful = _vala_successful;
	}
}

/**
     * This method ensures that the view switcher and search box are sensitive/insensitive
     * when they have to. It also selects the proper view switcher item based on the
     * current view.
     */
void
music_view_wrapper_update_library_window_widgets (MusicViewWrapper* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MusicViewWrapperHint _tmp10_;
	GEnumValue* _tmp11_;
	MusicLibraryWindow* _tmp12_;
	MusicLibraryWindow* _tmp13_;
	GtkSearchEntry* _tmp14_;
	GtkSearchEntry* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_;
	gboolean _tmp22_;
	MusicLibraryWindow* _tmp29_;
	MusicLibraryWindow* _tmp30_;
	MusicWidgetsViewSelector* _tmp31_;
	MusicWidgetsViewSelector* _tmp32_;
	gboolean _tmp33_ = FALSE;
	MusicListView* _tmp34_;
	MusicColumnBrowser* _tmp35_;
	MusicColumnBrowser* _tmp36_;
	MusicLibraryWindow* _tmp42_;
	MusicLibraryWindow* _tmp43_;
	MusicWidgetsViewSelector* _tmp44_;
	MusicWidgetsViewSelector* _tmp45_;
	MusicLibraryWindow* _tmp46_;
	MusicLibraryWindow* _tmp47_;
	MusicWidgetsViewSelector* _tmp48_;
	MusicWidgetsViewSelector* _tmp49_;
	g_return_if_fail (self != NULL);
	_tmp2_ = music_view_wrapper_get_is_current_wrapper (self);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = music_view_wrapper_get_has_list_view (self);
		_tmp5_ = _tmp4_;
		_tmp1_ = !_tmp5_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		MusicLibraryWindow* _tmp6_;
		MusicLibraryWindow* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp6_ = music_app_get_main_window ();
		_tmp7_ = _tmp6_;
		_tmp8_ = music_library_window_get_initialization_finished (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp0_ = !_tmp9_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp10_ = self->priv->_hint;
	_tmp11_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp10_);
	g_debug ("ViewWrapper.vala:227: update_library_window_widgets [%s]", (_tmp11_ != NULL) ? _tmp11_->value_name : NULL);
	_tmp12_ = music_app_get_main_window ();
	_tmp13_ = _tmp12_;
	_tmp14_ = music_library_window_get_search_entry (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = music_view_wrapper_get_media_count (self);
	_tmp17_ = _tmp16_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, _tmp17_ > 0);
	_tmp21_ = music_view_wrapper_get_has_grid_view (self);
	_tmp22_ = _tmp21_;
	if (_tmp22_) {
		gboolean _tmp23_;
		gboolean _tmp24_;
		_tmp23_ = music_view_wrapper_get_has_list_view (self);
		_tmp24_ = _tmp23_;
		_tmp20_ = _tmp24_;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		MusicViewWrapperViewType _tmp25_;
		MusicViewWrapperViewType _tmp26_;
		_tmp25_ = music_view_wrapper_get_current_view (self);
		_tmp26_ = _tmp25_;
		_tmp19_ = _tmp26_ != MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		MusicViewWrapperViewType _tmp27_;
		MusicViewWrapperViewType _tmp28_;
		_tmp27_ = music_view_wrapper_get_current_view (self);
		_tmp28_ = _tmp27_;
		_tmp18_ = _tmp28_ != MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT;
	} else {
		_tmp18_ = FALSE;
	}
	_tmp29_ = music_app_get_main_window ();
	_tmp30_ = _tmp29_;
	_tmp31_ = music_library_window_get_view_selector (_tmp30_);
	_tmp32_ = _tmp31_;
	music_widgets_view_selector_set_sensitive (_tmp32_, _tmp18_);
	_tmp34_ = self->priv->_list_view;
	_tmp35_ = music_list_view_get_column_browser (_tmp34_);
	_tmp36_ = _tmp35_;
	if (_tmp36_ != NULL) {
		MusicListView* _tmp37_;
		MusicColumnBrowser* _tmp38_;
		MusicColumnBrowser* _tmp39_;
		gboolean _tmp40_;
		gboolean _tmp41_;
		_tmp37_ = self->priv->_list_view;
		_tmp38_ = music_list_view_get_column_browser (_tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = gtk_widget_get_visible ((GtkWidget*) _tmp39_);
		_tmp41_ = _tmp40_;
		_tmp33_ = _tmp41_;
	} else {
		_tmp33_ = FALSE;
	}
	_tmp42_ = music_app_get_main_window ();
	_tmp43_ = _tmp42_;
	_tmp44_ = music_library_window_get_view_selector (_tmp43_);
	_tmp45_ = _tmp44_;
	music_widgets_view_selector_set_column_browser_toggle_active (_tmp45_, _tmp33_);
	_tmp46_ = music_app_get_main_window ();
	_tmp47_ = _tmp46_;
	_tmp48_ = music_library_window_get_view_selector (_tmp47_);
	_tmp49_ = _tmp48_;
	if (!music_widgets_view_selector_get_column_browser_toggle_active (_tmp49_)) {
		gboolean _tmp50_ = FALSE;
		MusicLibraryWindow* _tmp51_;
		MusicLibraryWindow* _tmp52_;
		MusicWidgetsViewSelector* _tmp53_;
		MusicWidgetsViewSelector* _tmp54_;
		MusicWidgetsViewSelectorMode _tmp55_;
		MusicWidgetsViewSelectorMode _tmp56_;
		MusicViewWrapperViewType _tmp57_;
		_tmp51_ = music_app_get_main_window ();
		_tmp52_ = _tmp51_;
		_tmp53_ = music_library_window_get_view_selector (_tmp52_);
		_tmp54_ = _tmp53_;
		_tmp55_ = music_widgets_view_selector_get_selected (_tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = self->priv->last_used_view;
		if (_tmp56_ != ((gint) _tmp57_)) {
			MusicViewWrapperViewType _tmp58_;
			_tmp58_ = self->priv->last_used_view;
			_tmp50_ = ((gint) _tmp58_) <= 1;
		} else {
			_tmp50_ = FALSE;
		}
		if (_tmp50_) {
			MusicLibraryWindow* _tmp59_;
			MusicLibraryWindow* _tmp60_;
			MusicWidgetsViewSelector* _tmp61_;
			MusicWidgetsViewSelector* _tmp62_;
			MusicViewWrapperViewType _tmp63_;
			_tmp59_ = music_app_get_main_window ();
			_tmp60_ = _tmp59_;
			_tmp61_ = music_library_window_get_view_selector (_tmp60_);
			_tmp62_ = _tmp61_;
			_tmp63_ = self->priv->last_used_view;
			music_widgets_view_selector_set_selected (_tmp62_, (MusicWidgetsViewSelectorMode) _tmp63_);
		}
	}
}

void
music_view_wrapper_view_selector_changed (MusicViewWrapper* self)
{
	gboolean _tmp0_ = FALSE;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	MusicViewWrapperViewType _tmp13_;
	MusicViewWrapperViewType _tmp14_;
	MusicViewWrapperHint _tmp19_;
	GEnumValue* _tmp20_;
	MusicViewWrapperViewType selected_view = 0;
	MusicLibraryWindow* _tmp21_;
	MusicLibraryWindow* _tmp22_;
	MusicWidgetsViewSelector* _tmp23_;
	MusicWidgetsViewSelector* _tmp24_;
	MusicWidgetsViewSelectorMode _tmp25_;
	MusicWidgetsViewSelectorMode _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	g_return_if_fail (self != NULL);
	_tmp1_ = music_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = music_library_window_get_initialization_finished (_tmp2_);
	_tmp4_ = _tmp3_;
	if (!_tmp4_) {
		_tmp0_ = TRUE;
	} else {
		MusicLibraryWindow* _tmp5_;
		MusicLibraryWindow* _tmp6_;
		MusicWidgetsViewSelector* _tmp7_;
		MusicWidgetsViewSelector* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp5_ = music_app_get_main_window ();
		_tmp6_ = _tmp5_;
		_tmp7_ = music_library_window_get_view_selector (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = music_widgets_view_selector_get_sensitive (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp0_ = !_tmp10_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp13_ = music_view_wrapper_get_current_view (self);
	_tmp14_ = _tmp13_;
	if (_tmp14_ == MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT) {
		gint _tmp15_;
		gint _tmp16_;
		_tmp15_ = music_view_wrapper_get_media_count (self);
		_tmp16_ = _tmp15_;
		_tmp12_ = _tmp16_ < 1;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		_tmp11_ = TRUE;
	} else {
		MusicViewWrapperViewType _tmp17_;
		MusicViewWrapperViewType _tmp18_;
		_tmp17_ = music_view_wrapper_get_current_view (self);
		_tmp18_ = _tmp17_;
		_tmp11_ = _tmp18_ == MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
	}
	if (_tmp11_) {
		return;
	}
	_tmp19_ = self->priv->_hint;
	_tmp20_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp19_);
	g_debug ("ViewWrapper.vala:264: view_selector_changed [%s]", (_tmp20_ != NULL) ? _tmp20_->value_name : NULL);
	_tmp21_ = music_app_get_main_window ();
	_tmp22_ = _tmp21_;
	_tmp23_ = music_library_window_get_view_selector (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = music_widgets_view_selector_get_selected (_tmp24_);
	_tmp26_ = _tmp25_;
	selected_view = (MusicViewWrapperViewType) _tmp26_;
	_tmp27_ = music_view_wrapper_get_is_current_wrapper (self);
	_tmp28_ = _tmp27_;
	if (_tmp28_) {
		MusicViewWrapperViewType _tmp29_;
		_tmp29_ = selected_view;
		music_view_wrapper_set_active_view (self, _tmp29_, NULL);
	} else {
		MusicViewWrapperViewType _tmp30_;
		_tmp30_ = selected_view;
		self->priv->last_used_view = _tmp30_;
	}
}

void
music_view_wrapper_play_first_media (MusicViewWrapper* self,
                                     gboolean* force)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	MusicListView* _tmp4_;
	MusicMedia* m = NULL;
	MusicPlaybackManager* _tmp5_;
	MusicPlaybackManager* _tmp6_;
	MusicMedia* _tmp7_;
	MusicMedia* _tmp8_;
	MusicPlaybackManager* _tmp9_;
	MusicPlaybackManager* _tmp10_;
	MusicMedia* _tmp11_;
	MusicPlaybackManager* _tmp12_;
	MusicPlaybackManager* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_view_wrapper_get_has_list_view (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->_hint;
	_tmp3_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
	g_debug ("ViewWrapper.vala:278: play_first_media [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
	_tmp4_ = self->priv->_list_view;
	music_list_view_set_as_current_list (_tmp4_, 1);
	_tmp5_ = music_app_get_player ();
	_tmp6_ = _tmp5_;
	_tmp7_ = music_playback_manager_media_from_current_index (_tmp6_, 0);
	m = _tmp7_;
	_tmp8_ = m;
	if (_tmp8_ == NULL) {
		_g_object_unref0 (m);
		return;
	}
	_tmp9_ = music_app_get_player ();
	_tmp10_ = _tmp9_;
	_tmp11_ = m;
	music_playback_manager_play_media (_tmp10_, _tmp11_);
	_tmp12_ = music_app_get_player ();
	_tmp13_ = _tmp12_;
	music_playback_manager_start_playback (_tmp13_);
	_g_object_unref0 (m);
}

/**
     * This handles updating all the shared stuff outside the view area.
     *
     * You should only call this method on the respective ViewWrapper whenever the sidebar's
     * selected view changes.
     *
     * Note: The sidebar-item selection and other stuff is handled automatically by the LibraryWindow
     *       by request of SideTreeView. See LibraryWindow :: set_active_view() for more details.
     */
void
music_view_wrapper_set_as_current_view (MusicViewWrapper* self)
{
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	MusicViewWrapperHint _tmp4_;
	GEnumValue* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_library_window_get_initialization_finished (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		return;
	}
	_tmp4_ = self->priv->_hint;
	_tmp5_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp4_);
	g_debug ("ViewWrapper.vala:301: SETTING AS CURRENT VIEW [%s]", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
	music_view_wrapper_update_visible_media (self);
	music_view_wrapper_check_have_media (self);
	music_view_wrapper_update_library_window_widgets (self);
}

static void
music_view_wrapper_search_field_changed (MusicViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_view_wrapper_get_is_current_wrapper (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	music_view_wrapper_update_visible_media (self);
}

static gboolean
music_view_wrapper_real_check_have_media (MusicViewWrapper* self)
{
	gboolean have_media = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gboolean result = FALSE;
	if (!self->priv->data_initialized) {
		result = FALSE;
		return result;
	}
	_tmp0_ = music_view_wrapper_get_media_count (self);
	_tmp1_ = _tmp0_;
	have_media = _tmp1_ > 0;
	if (have_media) {
		music_view_wrapper_select_proper_content_view (self);
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = music_view_wrapper_get_has_welcome_screen (self);
		_tmp3_ = _tmp2_;
		if (_tmp3_) {
			music_view_wrapper_set_active_view (self, MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME, NULL);
		} else {
			gboolean _tmp4_;
			gboolean _tmp5_;
			_tmp4_ = music_view_wrapper_get_has_embedded_alert (self);
			_tmp5_ = _tmp4_;
			if (_tmp5_) {
				music_view_wrapper_set_no_media_alert (self);
				music_view_wrapper_set_active_view (self, MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT, NULL);
			}
		}
	}
	result = have_media;
	return result;
}

gboolean
music_view_wrapper_check_have_media (MusicViewWrapper* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return MUSIC_VIEW_WRAPPER_GET_CLASS (self)->check_have_media (self);
}

static void
music_view_wrapper_real_select_proper_content_view (MusicViewWrapper* self)
{
	MusicViewWrapperViewType new_view = 0;
	MusicLibraryWindow* _tmp0_;
	MusicLibraryWindow* _tmp1_;
	MusicWidgetsViewSelector* _tmp2_;
	MusicWidgetsViewSelector* _tmp3_;
	MusicWidgetsViewSelectorMode _tmp4_;
	MusicWidgetsViewSelectorMode _tmp5_;
	static const gint N_VIEWS = 2;
	gboolean _tmp6_ = FALSE;
	MusicViewWrapperViewType _tmp7_;
	gboolean _tmp9_ = FALSE;
	MusicViewWrapperViewType _tmp10_;
	_tmp0_ = music_app_get_main_window ();
	_tmp1_ = _tmp0_;
	_tmp2_ = music_library_window_get_view_selector (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_widgets_view_selector_get_selected (_tmp3_);
	_tmp5_ = _tmp4_;
	new_view = (MusicViewWrapperViewType) _tmp5_;
	_tmp7_ = new_view;
	if (_tmp7_ < 0) {
		_tmp6_ = TRUE;
	} else {
		MusicViewWrapperViewType _tmp8_;
		_tmp8_ = new_view;
		_tmp6_ = _tmp8_ > (N_VIEWS - 1);
	}
	if (_tmp6_) {
		new_view = MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST;
	}
	_tmp10_ = new_view;
	if (_tmp10_ == MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST) {
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp11_ = music_view_wrapper_get_has_list_view (self);
		_tmp12_ = _tmp11_;
		_tmp9_ = _tmp12_;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		music_view_wrapper_set_active_view (self, MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST, NULL);
	} else {
		gboolean _tmp13_ = FALSE;
		MusicViewWrapperViewType _tmp14_;
		_tmp14_ = new_view;
		if (_tmp14_ == MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID) {
			gboolean _tmp15_;
			gboolean _tmp16_;
			_tmp15_ = music_view_wrapper_get_has_grid_view (self);
			_tmp16_ = _tmp15_;
			_tmp13_ = _tmp16_;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			music_view_wrapper_set_active_view (self, MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID, NULL);
		} else {
			gboolean _tmp17_;
			gboolean _tmp18_;
			_tmp17_ = music_view_wrapper_get_has_list_view (self);
			_tmp18_ = _tmp17_;
			if (_tmp18_) {
				MusicViewStack* _tmp19_;
				MusicListView* _tmp20_;
				_tmp19_ = self->priv->view_stack;
				_tmp20_ = self->priv->_list_view;
				gtk_stack_set_visible_child ((GtkStack*) _tmp19_, (GtkWidget*) _tmp20_);
			} else {
				gboolean _tmp21_;
				gboolean _tmp22_;
				_tmp21_ = music_view_wrapper_get_has_grid_view (self);
				_tmp22_ = _tmp21_;
				if (_tmp22_) {
					MusicViewStack* _tmp23_;
					MusicAlbumsView* _tmp24_;
					_tmp23_ = self->priv->view_stack;
					_tmp24_ = self->priv->_grid_view;
					gtk_stack_set_visible_child ((GtkStack*) _tmp23_, (GtkWidget*) _tmp24_);
				}
			}
		}
	}
}

void
music_view_wrapper_select_proper_content_view (MusicViewWrapper* self)
{
	g_return_if_fail (self != NULL);
	MUSIC_VIEW_WRAPPER_GET_CLASS (self)->select_proper_content_view (self);
}

/**
     * @return A collection containing ALL the media associated to this view.
     */
GeeCollection*
music_view_wrapper_get_media_list (MusicViewWrapper* self)
{
	MusicListView* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_list_view;
	_tmp1_ = music_view_interface_get_media ((MusicViewInterface*) _tmp0_);
	result = _tmp1_;
	return result;
}

/**
     * Resets all the filters (external and internal) applied to a view inside
     * the view wrapper. It should only be called if the view is the current active
     * wrapper.
     */
void
music_view_wrapper_clear_filters (MusicViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_view_wrapper_get_is_current_wrapper (self);
	_tmp1_ = _tmp0_;
	_vala_return_if_fail (_tmp1_, "is_current_wrapper");
	music_view_wrapper_update_visible_media (self);
}

/**
     * Updates the data in visible_media and re-populates all the views.
     * Primarily used for searches
     */
void
music_view_wrapper_update_visible_media (MusicViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = music_view_wrapper_get_is_current_wrapper (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->_hint;
	_tmp3_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
	g_debug ("ViewWrapper.vala:401: UPDATING VISIBLE MEDIA [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
	_tmp4_ = music_view_wrapper_get_has_list_view (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		{
			MusicListView* _tmp6_;
			_tmp6_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_list_view);
			{
				MusicListView* _tmp7_;
				_tmp7_ = self->priv->_list_view;
				music_view_interface_refilter ((MusicViewInterface*) _tmp7_);
			}
			__finally0:
			{
				MusicListView* _tmp8_;
				_tmp8_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp9_ = music_view_wrapper_get_has_grid_view (self);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		{
			MusicAlbumsView* _tmp11_;
			_tmp11_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
			{
				MusicAlbumsView* _tmp12_;
				_tmp12_ = self->priv->_grid_view;
				music_view_interface_refilter ((MusicViewInterface*) _tmp12_);
			}
			__finally1:
			{
				MusicAlbumsView* _tmp13_;
				_tmp13_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
}

static void
music_view_wrapper_real_set_no_media_alert (MusicViewWrapper* self)
{
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	_tmp0_ = self->priv->_embedded_alert;
	granite_widgets_alert_view_set_icon_name (_tmp0_, "dialog-information");
	_tmp1_ = self->priv->_embedded_alert;
	granite_widgets_alert_view_set_title (_tmp1_, _ ("No media"));
}

void
music_view_wrapper_set_no_media_alert (MusicViewWrapper* self)
{
	g_return_if_fail (self != NULL);
	MUSIC_VIEW_WRAPPER_GET_CLASS (self)->set_no_media_alert (self);
}

static void
music_view_wrapper_set_media_async_data_free (gpointer _data)
{
	MusicViewWrapperSetMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->new_media);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicViewWrapperSetMediaAsyncData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
music_view_wrapper_set_media_async (MusicViewWrapper* self,
                                    GeeCollection* new_media,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	MusicViewWrapperSetMediaAsyncData* _data_;
	MusicViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (MusicViewWrapperSetMediaAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_view_wrapper_set_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (new_media);
	_g_object_unref0 (_data_->new_media);
	_data_->new_media = _tmp1_;
	music_view_wrapper_set_media_async_co (_data_);
}

void
music_view_wrapper_set_media_finish (MusicViewWrapper* self,
                                     GAsyncResult* _res_)
{
	MusicViewWrapperSetMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
music_view_wrapper_set_media_async_co (MusicViewWrapperSetMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (!_data_->self->priv->widgets_ready) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	music_view_wrapper_set_media (_data_->self, _data_->new_media);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
music_view_wrapper_add_media_async_data_free (gpointer _data)
{
	MusicViewWrapperAddMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->to_add);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicViewWrapperAddMediaAsyncData, _data_);
}

void
music_view_wrapper_add_media_async (MusicViewWrapper* self,
                                    GeeCollection* to_add,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	MusicViewWrapperAddMediaAsyncData* _data_;
	MusicViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (MusicViewWrapperAddMediaAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_view_wrapper_add_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (to_add);
	_g_object_unref0 (_data_->to_add);
	_data_->to_add = _tmp1_;
	music_view_wrapper_add_media_async_co (_data_);
}

void
music_view_wrapper_add_media_finish (MusicViewWrapper* self,
                                     GAsyncResult* _res_)
{
	MusicViewWrapperAddMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
music_view_wrapper_add_media_async_co (MusicViewWrapperAddMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (!_data_->self->priv->widgets_ready) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	music_view_wrapper_add_media (_data_->self, _data_->to_add);
	music_view_wrapper_update_visible_media (_data_->self);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
music_view_wrapper_remove_media_async_data_free (gpointer _data)
{
	MusicViewWrapperRemoveMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->to_remove);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicViewWrapperRemoveMediaAsyncData, _data_);
}

void
music_view_wrapper_remove_media_async (MusicViewWrapper* self,
                                       GeeCollection* to_remove,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	MusicViewWrapperRemoveMediaAsyncData* _data_;
	MusicViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (MusicViewWrapperRemoveMediaAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_view_wrapper_remove_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (to_remove);
	_g_object_unref0 (_data_->to_remove);
	_data_->to_remove = _tmp1_;
	music_view_wrapper_remove_media_async_co (_data_);
}

void
music_view_wrapper_remove_media_finish (MusicViewWrapper* self,
                                        GAsyncResult* _res_)
{
	MusicViewWrapperRemoveMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
music_view_wrapper_remove_media_async_co (MusicViewWrapperRemoveMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (!_data_->self->priv->widgets_ready) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	music_view_wrapper_remove_media (_data_->self, _data_->to_remove);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
music_view_wrapper_update_media_async_data_free (gpointer _data)
{
	MusicViewWrapperUpdateMediaAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->to_update);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicViewWrapperUpdateMediaAsyncData, _data_);
}

void
music_view_wrapper_update_media_async (MusicViewWrapper* self,
                                       GeeCollection* to_update,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	MusicViewWrapperUpdateMediaAsyncData* _data_;
	MusicViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
	_data_ = g_slice_new0 (MusicViewWrapperUpdateMediaAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_view_wrapper_update_media_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (to_update);
	_g_object_unref0 (_data_->to_update);
	_data_->to_update = _tmp1_;
	music_view_wrapper_update_media_async_co (_data_);
}

void
music_view_wrapper_update_media_finish (MusicViewWrapper* self,
                                        GAsyncResult* _res_)
{
	MusicViewWrapperUpdateMediaAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
music_view_wrapper_update_media_async_co (MusicViewWrapperUpdateMediaAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (!_data_->self->priv->widgets_ready) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	music_view_wrapper_update_media (_data_->self, _data_->to_update);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
music_view_wrapper_set_media (MusicViewWrapper* self,
                              GeeCollection* new_media)
{
	MusicViewWrapperHint _tmp0_;
	GEnumValue* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_media != NULL);
	_tmp0_ = self->priv->_hint;
	_tmp1_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp0_);
	g_debug ("ViewWrapper.vala:447: SETTING MEDIA [%s]", (_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
	_tmp2_ = music_view_wrapper_get_has_list_view (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		{
			MusicListView* _tmp4_;
			_tmp4_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_list_view);
			{
				MusicListView* _tmp5_;
				_tmp5_ = self->priv->_list_view;
				music_view_interface_set_media ((MusicViewInterface*) _tmp5_, new_media);
			}
			__finally0:
			{
				MusicListView* _tmp6_;
				_tmp6_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp7_ = music_view_wrapper_get_has_grid_view (self);
	_tmp8_ = _tmp7_;
	if (_tmp8_) {
		{
			MusicAlbumsView* _tmp9_;
			_tmp9_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
			{
				MusicAlbumsView* _tmp10_;
				_tmp10_ = self->priv->_grid_view;
				music_view_interface_set_media ((MusicViewInterface*) _tmp10_, new_media);
			}
			__finally1:
			{
				MusicAlbumsView* _tmp11_;
				_tmp11_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	self->priv->data_initialized = TRUE;
	music_view_wrapper_update_visible_media (self);
	music_view_wrapper_update_widget_state (self);
}

static void
music_view_wrapper_update_media (MusicViewWrapper* self,
                                 GeeCollection* media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media != NULL);
	_vala_return_if_fail (self->priv->data_initialized, "data_initialized");
	_tmp0_ = gee_collection_get_is_empty (media);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->_hint;
	_tmp3_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
	g_debug ("ViewWrapper.vala:471: UPDATING MEDIA [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
	_tmp4_ = music_view_wrapper_get_has_list_view (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		{
			MusicListView* _tmp6_;
			_tmp6_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_list_view);
			{
				MusicListView* _tmp7_;
				_tmp7_ = self->priv->_list_view;
				music_view_interface_update_media ((MusicViewInterface*) _tmp7_, media);
			}
			__finally0:
			{
				MusicListView* _tmp8_;
				_tmp8_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp9_ = music_view_wrapper_get_has_grid_view (self);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		{
			MusicAlbumsView* _tmp11_;
			_tmp11_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
			{
				MusicAlbumsView* _tmp12_;
				_tmp12_ = self->priv->_grid_view;
				music_view_interface_update_media ((MusicViewInterface*) _tmp12_, media);
			}
			__finally1:
			{
				MusicAlbumsView* _tmp13_;
				_tmp13_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	music_view_wrapper_update_widget_state (self);
}

static void
music_view_wrapper_add_media (MusicViewWrapper* self,
                              GeeCollection* new_media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_media != NULL);
	_vala_return_if_fail (self->priv->data_initialized, "data_initialized");
	_tmp0_ = gee_collection_get_is_empty (new_media);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		return;
	}
	_tmp2_ = music_view_wrapper_get_has_list_view (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		{
			MusicListView* _tmp4_;
			_tmp4_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_list_view);
			{
				MusicListView* _tmp5_;
				_tmp5_ = self->priv->_list_view;
				music_view_interface_add_media ((MusicViewInterface*) _tmp5_, new_media);
			}
			__finally0:
			{
				MusicListView* _tmp6_;
				_tmp6_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp7_ = music_view_wrapper_get_has_grid_view (self);
	_tmp8_ = _tmp7_;
	if (_tmp8_) {
		{
			MusicAlbumsView* _tmp9_;
			_tmp9_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
			{
				MusicAlbumsView* _tmp10_;
				_tmp10_ = self->priv->_grid_view;
				music_view_interface_add_media ((MusicViewInterface*) _tmp10_, new_media);
			}
			__finally1:
			{
				MusicAlbumsView* _tmp11_;
				_tmp11_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	music_view_wrapper_update_widget_state (self);
}

static void
music_view_wrapper_remove_media (MusicViewWrapper* self,
                                 GeeCollection* media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	MusicViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (media != NULL);
	_vala_return_if_fail (self->priv->data_initialized, "data_initialized");
	_tmp0_ = gee_collection_get_is_empty (media);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->_hint;
	_tmp3_ = g_enum_get_value (g_type_class_ref (MUSIC_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
	g_debug ("ViewWrapper.vala:511: REMOVING MEDIA [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
	_tmp4_ = music_view_wrapper_get_has_list_view (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		{
			MusicListView* _tmp6_;
			_tmp6_ = self->priv->_list_view;
			g_rec_mutex_lock (&self->priv->__lock_list_view);
			{
				MusicListView* _tmp7_;
				_tmp7_ = self->priv->_list_view;
				music_view_interface_remove_media ((MusicViewInterface*) _tmp7_, media);
			}
			__finally0:
			{
				MusicListView* _tmp8_;
				_tmp8_ = self->priv->_list_view;
				g_rec_mutex_unlock (&self->priv->__lock_list_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp9_ = music_view_wrapper_get_has_grid_view (self);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		{
			MusicAlbumsView* _tmp11_;
			_tmp11_ = self->priv->_grid_view;
			g_rec_mutex_lock (&self->priv->__lock_grid_view);
			{
				MusicAlbumsView* _tmp12_;
				_tmp12_ = self->priv->_grid_view;
				music_view_interface_remove_media ((MusicViewInterface*) _tmp12_, media);
			}
			__finally1:
			{
				MusicAlbumsView* _tmp13_;
				_tmp13_ = self->priv->_grid_view;
				g_rec_mutex_unlock (&self->priv->__lock_grid_view);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	music_view_wrapper_update_widget_state (self);
}

static void
music_view_wrapper_update_widget_state (MusicViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	music_view_wrapper_check_have_media (self);
	_tmp0_ = music_view_wrapper_get_is_current_wrapper (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		music_view_wrapper_update_library_window_widgets (self);
	}
}

MusicListView*
music_view_wrapper_get_list_view (MusicViewWrapper* self)
{
	MusicListView* result;
	MusicListView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_list_view;
	result = _tmp0_;
	return result;
}

void
music_view_wrapper_set_list_view (MusicViewWrapper* self,
                                  MusicListView* value)
{
	MusicListView* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_view_wrapper_get_list_view (self);
	if (old_value != value) {
		MusicListView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_list_view);
		self->priv->_list_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY]);
	}
}

MusicAlbumsView*
music_view_wrapper_get_grid_view (MusicViewWrapper* self)
{
	MusicAlbumsView* result;
	MusicAlbumsView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_grid_view;
	result = _tmp0_;
	return result;
}

void
music_view_wrapper_set_grid_view (MusicViewWrapper* self,
                                  MusicAlbumsView* value)
{
	MusicAlbumsView* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_view_wrapper_get_grid_view (self);
	if (old_value != value) {
		MusicAlbumsView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_grid_view);
		self->priv->_grid_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY]);
	}
}

GraniteWidgetsAlertView*
music_view_wrapper_get_embedded_alert (MusicViewWrapper* self)
{
	GraniteWidgetsAlertView* result;
	GraniteWidgetsAlertView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_embedded_alert;
	result = _tmp0_;
	return result;
}

void
music_view_wrapper_set_embedded_alert (MusicViewWrapper* self,
                                       GraniteWidgetsAlertView* value)
{
	GraniteWidgetsAlertView* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_view_wrapper_get_embedded_alert (self);
	if (old_value != value) {
		GraniteWidgetsAlertView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_embedded_alert);
		self->priv->_embedded_alert = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY]);
	}
}

GraniteWidgetsWelcome*
music_view_wrapper_get_welcome_screen (MusicViewWrapper* self)
{
	GraniteWidgetsWelcome* result;
	GraniteWidgetsWelcome* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_welcome_screen;
	result = _tmp0_;
	return result;
}

void
music_view_wrapper_set_welcome_screen (MusicViewWrapper* self,
                                       GraniteWidgetsWelcome* value)
{
	GraniteWidgetsWelcome* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_view_wrapper_get_welcome_screen (self);
	if (old_value != value) {
		GraniteWidgetsWelcome* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_welcome_screen);
		self->priv->_welcome_screen = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY]);
	}
}

gboolean
music_view_wrapper_get_has_grid_view (MusicViewWrapper* self)
{
	gboolean result;
	MusicAlbumsView* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_grid_view;
	result = _tmp0_ != NULL;
	return result;
}

gboolean
music_view_wrapper_get_has_list_view (MusicViewWrapper* self)
{
	gboolean result;
	MusicListView* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_list_view;
	result = _tmp0_ != NULL;
	return result;
}

gboolean
music_view_wrapper_get_has_embedded_alert (MusicViewWrapper* self)
{
	gboolean result;
	GraniteWidgetsAlertView* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_embedded_alert;
	result = _tmp0_ != NULL;
	return result;
}

gboolean
music_view_wrapper_get_has_welcome_screen (MusicViewWrapper* self)
{
	gboolean result;
	GraniteWidgetsWelcome* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_welcome_screen;
	result = _tmp0_ != NULL;
	return result;
}

MusicViewWrapperViewType
music_view_wrapper_get_current_view (MusicViewWrapper* self)
{
	MusicViewWrapperViewType result;
	GtkWidget* view = NULL;
	MusicViewStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	MusicAlbumsView* _tmp5_;
	GtkWidget* _tmp6_;
	MusicListView* _tmp7_;
	GtkWidget* _tmp8_;
	GraniteWidgetsAlertView* _tmp9_;
	GtkWidget* _tmp10_;
	GraniteWidgetsWelcome* _tmp11_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->view_stack;
	_tmp1_ = gtk_stack_get_visible_child ((GtkStack*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	view = _tmp3_;
	_tmp4_ = view;
	_tmp5_ = self->priv->_grid_view;
	if (_tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget)) {
		result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_GRID;
		_g_object_unref0 (view);
		return result;
	}
	_tmp6_ = view;
	_tmp7_ = self->priv->_list_view;
	if (_tmp6_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget)) {
		result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_LIST;
		_g_object_unref0 (view);
		return result;
	}
	_tmp8_ = view;
	_tmp9_ = self->priv->_embedded_alert;
	if (_tmp8_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget)) {
		result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_ALERT;
		_g_object_unref0 (view);
		return result;
	}
	_tmp10_ = view;
	_tmp11_ = self->priv->_welcome_screen;
	if (_tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget)) {
		result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
		_g_object_unref0 (view);
		return result;
	}
	result = MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE;
	_g_object_unref0 (view);
	return result;
}

MusicViewWrapperHint
music_view_wrapper_get_hint (MusicViewWrapper* self)
{
	MusicViewWrapperHint result;
	MusicViewWrapperHint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_hint;
	result = _tmp0_;
	return result;
}

void
music_view_wrapper_set_hint (MusicViewWrapper* self,
                             MusicViewWrapperHint value)
{
	MusicViewWrapperHint old_value;
	g_return_if_fail (self != NULL);
	old_value = music_view_wrapper_get_hint (self);
	if (old_value != value) {
		self->priv->_hint = value;
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HINT_PROPERTY]);
	}
}

MusicLibrary*
music_view_wrapper_get_library (MusicViewWrapper* self)
{
	MusicLibrary* result;
	MusicLibrary* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_library;
	result = _tmp0_;
	return result;
}

void
music_view_wrapper_set_library (MusicViewWrapper* self,
                                MusicLibrary* value)
{
	MusicLibrary* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_view_wrapper_get_library (self);
	if (old_value != value) {
		MusicLibrary* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_library);
		self->priv->_library = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY]);
	}
}

gboolean
music_view_wrapper_get_is_current_wrapper (MusicViewWrapper* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	MusicLibraryWindow* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = music_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = music_library_window_get_initialization_finished (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		MusicLibraryWindow* _tmp5_;
		MusicLibraryWindow* _tmp6_;
		MusicViewStack* _tmp7_;
		MusicViewStack* _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
		_tmp5_ = music_app_get_main_window ();
		_tmp6_ = _tmp5_;
		_tmp7_ = music_library_window_get_view_stack (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = gtk_stack_get_visible_child ((GtkStack*) _tmp8_);
		_tmp10_ = _tmp9_;
		_tmp0_ = _tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

MusicPlaylist*
music_view_wrapper_get_playlist (MusicViewWrapper* self)
{
	MusicPlaylist* result;
	MusicPlaylist* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_playlist;
	result = _tmp0_;
	return result;
}

void
music_view_wrapper_set_playlist (MusicViewWrapper* self,
                                 MusicPlaylist* value)
{
	MusicPlaylist* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_view_wrapper_get_playlist (self);
	if (old_value != value) {
		MusicPlaylist* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_playlist);
		self->priv->_playlist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY]);
	}
}

gint
music_view_wrapper_get_media_count (MusicViewWrapper* self)
{
	gint result;
	MusicListView* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_list_view;
	_tmp1_ = music_list_view_get_n_media (_tmp0_);
	_tmp2_ = _tmp1_;
	result = (gint) _tmp2_;
	return result;
}

static void
_music_view_wrapper_view_selector_changed_music_widgets_view_selector_mode_changed (MusicWidgetsViewSelector* _sender,
                                                                                    MusicWidgetsViewSelectorMode new_mode,
                                                                                    gpointer self)
{
	music_view_wrapper_view_selector_changed ((MusicViewWrapper*) self);
}

static void
_music_view_wrapper_search_field_changed_music_library_search_finished (MusicLibrary* _sender,
                                                                        gpointer self)
{
	music_view_wrapper_search_field_changed ((MusicViewWrapper*) self);
}

static GObject *
music_view_wrapper_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicViewWrapper * self;
	MusicViewStack* _tmp0_;
	MusicViewStack* _tmp1_;
	MusicLibraryWindow* _tmp2_;
	MusicLibraryWindow* _tmp3_;
	MusicWidgetsViewSelector* _tmp4_;
	MusicWidgetsViewSelector* _tmp5_;
	MusicLibrary* _tmp6_;
	parent_class = G_OBJECT_CLASS (music_view_wrapper_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp0_ = music_view_stack_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->view_stack);
	self->priv->view_stack = _tmp0_;
	_tmp1_ = self->priv->view_stack;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
	_tmp2_ = music_app_get_main_window ();
	_tmp3_ = _tmp2_;
	_tmp4_ = music_library_window_get_view_selector (_tmp3_);
	_tmp5_ = _tmp4_;
	g_signal_connect_object (_tmp5_, "mode-changed", (GCallback) _music_view_wrapper_view_selector_changed_music_widgets_view_selector_mode_changed, self, 0);
	_tmp6_ = self->priv->_library;
	g_signal_connect_object (_tmp6_, "search-finished", (GCallback) _music_view_wrapper_search_field_changed_music_library_search_finished, self, 0);
	return obj;
}

static void
music_view_wrapper_class_init (MusicViewWrapperClass * klass,
                               gpointer klass_data)
{
	music_view_wrapper_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicViewWrapper_private_offset);
	((MusicViewWrapperClass *) klass)->check_have_media = (gboolean (*) (MusicViewWrapper*)) music_view_wrapper_real_check_have_media;
	((MusicViewWrapperClass *) klass)->select_proper_content_view = (void (*) (MusicViewWrapper*)) music_view_wrapper_real_select_proper_content_view;
	((MusicViewWrapperClass *) klass)->set_no_media_alert = (void (*) (MusicViewWrapper*)) music_view_wrapper_real_set_no_media_alert;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_view_wrapper_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_view_wrapper_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_view_wrapper_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_view_wrapper_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY] = g_param_spec_object ("list-view", "list-view", "list-view", MUSIC_TYPE_LIST_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY] = g_param_spec_object ("grid-view", "grid-view", "grid-view", MUSIC_TYPE_ALBUMS_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY] = g_param_spec_object ("embedded-alert", "embedded-alert", "embedded-alert", GRANITE_WIDGETS_TYPE_ALERT_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY] = g_param_spec_object ("welcome-screen", "welcome-screen", "welcome-screen", GRANITE_WIDGETS_TYPE_WELCOME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY] = g_param_spec_boolean ("has-grid-view", "has-grid-view", "has-grid-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY] = g_param_spec_boolean ("has-list-view", "has-list-view", "has-list-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY] = g_param_spec_boolean ("has-embedded-alert", "has-embedded-alert", "has-embedded-alert", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY] = g_param_spec_boolean ("has-welcome-screen", "has-welcome-screen", "has-welcome-screen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY] = g_param_spec_enum ("current-view", "current-view", "current-view", MUSIC_VIEW_WRAPPER_TYPE_VIEW_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	     * This is by far the most important property of this object.
	     * It defines how child widgets behave and some other properties.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_HINT_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", MUSIC_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY] = g_param_spec_object ("library", "library", "library", MUSIC_TYPE_LIBRARY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY] = g_param_spec_boolean ("is-current-wrapper", "is-current-wrapper", "is-current-wrapper", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY] = g_param_spec_object ("playlist", "playlist", "playlist", MUSIC_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY, music_view_wrapper_properties[MUSIC_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY] = g_param_spec_int ("media-count", "media-count", "media-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
music_view_wrapper_instance_init (MusicViewWrapper * self,
                                  gpointer klass)
{
	self->priv = music_view_wrapper_get_instance_private (self);
	self->priv->_playlist = NULL;
	self->priv->widgets_ready = FALSE;
	self->priv->last_used_view = MUSIC_VIEW_WRAPPER_VIEW_TYPE_NONE;
	self->priv->data_initialized = FALSE;
	g_rec_mutex_init (&self->priv->__lock_list_view);
	g_rec_mutex_init (&self->priv->__lock_grid_view);
}

static void
music_view_wrapper_finalize (GObject * obj)
{
	MusicViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper);
	_g_object_unref0 (self->priv->_list_view);
	_g_object_unref0 (self->priv->_grid_view);
	_g_object_unref0 (self->priv->_embedded_alert);
	_g_object_unref0 (self->priv->_welcome_screen);
	_g_object_unref0 (self->priv->_library);
	_g_object_unref0 (self->priv->_playlist);
	_g_object_unref0 (self->priv->view_stack);
	g_rec_mutex_clear (&self->priv->__lock_list_view);
	g_rec_mutex_clear (&self->priv->__lock_grid_view);
	G_OBJECT_CLASS (music_view_wrapper_parent_class)->finalize (obj);
}

static GType
music_view_wrapper_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicViewWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_view_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicViewWrapper), 0, (GInstanceInitFunc) music_view_wrapper_instance_init, NULL };
	GType music_view_wrapper_type_id;
	music_view_wrapper_type_id = g_type_register_static (gtk_grid_get_type (), "MusicViewWrapper", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MusicViewWrapper_private_offset = g_type_add_instance_private (music_view_wrapper_type_id, sizeof (MusicViewWrapperPrivate));
	return music_view_wrapper_type_id;
}

GType
music_view_wrapper_get_type (void)
{
	static volatile gsize music_view_wrapper_type_id__volatile = 0;
	if (g_once_init_enter (&music_view_wrapper_type_id__volatile)) {
		GType music_view_wrapper_type_id;
		music_view_wrapper_type_id = music_view_wrapper_get_type_once ();
		g_once_init_leave (&music_view_wrapper_type_id__volatile, music_view_wrapper_type_id);
	}
	return music_view_wrapper_type_id__volatile;
}

static void
_vala_music_view_wrapper_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MusicViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper);
	switch (property_id) {
		case MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY:
		g_value_set_object (value, music_view_wrapper_get_list_view (self));
		break;
		case MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY:
		g_value_set_object (value, music_view_wrapper_get_grid_view (self));
		break;
		case MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY:
		g_value_set_object (value, music_view_wrapper_get_embedded_alert (self));
		break;
		case MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY:
		g_value_set_object (value, music_view_wrapper_get_welcome_screen (self));
		break;
		case MUSIC_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY:
		g_value_set_boolean (value, music_view_wrapper_get_has_grid_view (self));
		break;
		case MUSIC_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY:
		g_value_set_boolean (value, music_view_wrapper_get_has_list_view (self));
		break;
		case MUSIC_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY:
		g_value_set_boolean (value, music_view_wrapper_get_has_embedded_alert (self));
		break;
		case MUSIC_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY:
		g_value_set_boolean (value, music_view_wrapper_get_has_welcome_screen (self));
		break;
		case MUSIC_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY:
		g_value_set_enum (value, music_view_wrapper_get_current_view (self));
		break;
		case MUSIC_VIEW_WRAPPER_HINT_PROPERTY:
		g_value_set_enum (value, music_view_wrapper_get_hint (self));
		break;
		case MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY:
		g_value_set_object (value, music_view_wrapper_get_library (self));
		break;
		case MUSIC_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY:
		g_value_set_boolean (value, music_view_wrapper_get_is_current_wrapper (self));
		break;
		case MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY:
		g_value_set_object (value, music_view_wrapper_get_playlist (self));
		break;
		case MUSIC_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY:
		g_value_set_int (value, music_view_wrapper_get_media_count (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_view_wrapper_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MusicViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_VIEW_WRAPPER, MusicViewWrapper);
	switch (property_id) {
		case MUSIC_VIEW_WRAPPER_LIST_VIEW_PROPERTY:
		music_view_wrapper_set_list_view (self, g_value_get_object (value));
		break;
		case MUSIC_VIEW_WRAPPER_GRID_VIEW_PROPERTY:
		music_view_wrapper_set_grid_view (self, g_value_get_object (value));
		break;
		case MUSIC_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY:
		music_view_wrapper_set_embedded_alert (self, g_value_get_object (value));
		break;
		case MUSIC_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY:
		music_view_wrapper_set_welcome_screen (self, g_value_get_object (value));
		break;
		case MUSIC_VIEW_WRAPPER_HINT_PROPERTY:
		music_view_wrapper_set_hint (self, g_value_get_enum (value));
		break;
		case MUSIC_VIEW_WRAPPER_LIBRARY_PROPERTY:
		music_view_wrapper_set_library (self, g_value_get_object (value));
		break;
		case MUSIC_VIEW_WRAPPER_PLAYLIST_PROPERTY:
		music_view_wrapper_set_playlist (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

