/* Streamer.c generated by valac 0.48.17, the Vala compiler
 * generated from Streamer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gst/gst.h>
#include <glib.h>
#include <granite.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gst/pbutils/pbutils.h>
#include <gtk/gtk.h>

#define MUSIC_TYPE_STREAMER (music_streamer_get_type ())
#define MUSIC_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_STREAMER, MusicStreamer))
#define MUSIC_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_STREAMER, MusicStreamerClass))
#define MUSIC_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_STREAMER))
#define MUSIC_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_STREAMER))
#define MUSIC_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_STREAMER, MusicStreamerClass))

typedef struct _MusicStreamer MusicStreamer;
typedef struct _MusicStreamerClass MusicStreamerClass;
typedef struct _MusicStreamerPrivate MusicStreamerPrivate;

#define MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG (music_install_gstreamer_plugins_dialog_get_type ())
#define MUSIC_INSTALL_GSTREAMER_PLUGINS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, MusicInstallGstreamerPluginsDialog))
#define MUSIC_INSTALL_GSTREAMER_PLUGINS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, MusicInstallGstreamerPluginsDialogClass))
#define MUSIC_IS_INSTALL_GSTREAMER_PLUGINS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG))
#define MUSIC_IS_INSTALL_GSTREAMER_PLUGINS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG))
#define MUSIC_INSTALL_GSTREAMER_PLUGINS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_INSTALL_GSTREAMER_PLUGINS_DIALOG, MusicInstallGstreamerPluginsDialogClass))

typedef struct _MusicInstallGstreamerPluginsDialog MusicInstallGstreamerPluginsDialog;
typedef struct _MusicInstallGstreamerPluginsDialogClass MusicInstallGstreamerPluginsDialogClass;
enum  {
	MUSIC_STREAMER_0_PROPERTY,
	MUSIC_STREAMER_NUM_PROPERTIES
};
static GParamSpec* music_streamer_properties[MUSIC_STREAMER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define MUSIC_TYPE_PLAYBACK_MANAGER (music_playback_manager_get_type ())
#define MUSIC_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManager))
#define MUSIC_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))
#define MUSIC_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_PLAYBACK_MANAGER))
#define MUSIC_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_PLAYBACK_MANAGER, MusicPlaybackManagerClass))

typedef struct _MusicPlaybackManager MusicPlaybackManager;
typedef struct _MusicPlaybackManagerClass MusicPlaybackManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _MusicStreamer {
	GObject parent_instance;
	MusicStreamerPrivate * priv;
	GstElement* cdda;
	gboolean set_resume_pos;
};

struct _MusicStreamerClass {
	GObjectClass parent_class;
};

struct _MusicStreamerPrivate {
	MusicPipeline* pipe;
	MusicInstallGstreamerPluginsDialog* dialog;
};

static gint MusicStreamer_private_offset;
static gpointer music_streamer_parent_class = NULL;
static MusicPlaybackIface * music_streamer_music_playback_parent_iface = NULL;

GType music_streamer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicStreamer, g_object_unref)
GType music_install_gstreamer_plugins_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicInstallGstreamerPluginsDialog, g_object_unref)
MusicStreamer* music_streamer_new (void);
MusicStreamer* music_streamer_construct (GType object_type);
static gboolean music_streamer_bus_callback (MusicStreamer* self,
                                      GstBus* bus,
                                      GstMessage* message);
static gboolean _music_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self);
static gboolean _music_playback_update_position_gsource_func (gpointer self);
static GeeCollection* music_streamer_real_get_supported_uri (MusicPlayback* base);
static gboolean music_streamer_real_update_position (MusicPlayback* base);
GType music_playback_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPlaybackManager, g_object_unref)
MusicPlaybackManager* music_app_get_player (void);
MusicMedia* music_playback_manager_get_current_media (MusicPlaybackManager* self);
static void music_streamer_real_play (MusicPlayback* base);
static void music_streamer_real_pause (MusicPlayback* base);
static void music_streamer_real_set_state (MusicPlayback* base,
                                    GstState s);
static void music_streamer_real_set_media (MusicPlayback* base,
                                    MusicMedia* media);
static void music_streamer_real_set_position (MusicPlayback* base,
                                       gint64 pos);
static gint64 music_streamer_real_get_position (MusicPlayback* base);
static gint64 music_streamer_real_get_duration (MusicPlayback* base);
static void music_streamer_real_set_volume (MusicPlayback* base,
                                     gdouble val);
static gdouble music_streamer_real_get_volume (MusicPlayback* base);
static void music_streamer_real_enable_equalizer (MusicPlayback* base);
static void music_streamer_real_disable_equalizer (MusicPlayback* base);
static void music_streamer_real_set_equalizer_gain (MusicPlayback* base,
                                             gint index,
                                             gint val);
MusicInstallGstreamerPluginsDialog* music_install_gstreamer_plugins_dialog_new (GstMessage* message);
MusicInstallGstreamerPluginsDialog* music_install_gstreamer_plugins_dialog_construct (GType object_type,
                                                                                      GstMessage* message);
static void music_streamer_finalize (GObject * obj);
static GType music_streamer_get_type_once (void);

static inline gpointer
music_streamer_get_instance_private (MusicStreamer* self)
{
	return G_STRUCT_MEMBER_P (self, MusicStreamer_private_offset);
}

static gboolean
_music_streamer_bus_callback_gst_bus_func (GstBus* bus,
                                           GstMessage* message,
                                           gpointer self)
{
	gboolean result;
	result = music_streamer_bus_callback ((MusicStreamer*) self, bus, message);
	return result;
}

static gboolean
_music_playback_update_position_gsource_func (gpointer self)
{
	gboolean result;
	result = music_playback_update_position ((MusicPlayback*) self);
	return result;
}

MusicStreamer*
music_streamer_construct (GType object_type)
{
	MusicStreamer * self = NULL;
	MusicPipeline* _tmp0_;
	MusicPipeline* _tmp1_;
	GstBus* _tmp2_;
	self = (MusicStreamer*) g_object_new (object_type, NULL);
	_tmp0_ = music_pipeline_new ();
	_g_object_unref0 (self->priv->pipe);
	self->priv->pipe = _tmp0_;
	_tmp1_ = self->priv->pipe;
	_tmp2_ = _tmp1_->bus;
	gst_bus_add_watch_full (_tmp2_, G_PRIORITY_DEFAULT, _music_streamer_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _music_playback_update_position_gsource_func, g_object_ref ((MusicPlayback*) self), g_object_unref);
	return self;
}

MusicStreamer*
music_streamer_new (void)
{
	return music_streamer_construct (MUSIC_TYPE_STREAMER);
}

static GeeCollection*
music_streamer_real_get_supported_uri (MusicPlayback* base)
{
	MusicStreamer * self;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result = NULL;
	self = (MusicStreamer*) base;
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	uris = _tmp0_;
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "file://");
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "http://");
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "smb://");
	result = (GeeCollection*) uris;
	return result;
}

static gboolean
music_streamer_real_update_position (MusicPlayback* base)
{
	MusicStreamer * self;
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	self = (MusicStreamer*) base;
	if (self->set_resume_pos) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp1_ = FALSE;
		MusicPlaybackManager* _tmp2_;
		MusicPlaybackManager* _tmp3_;
		MusicMedia* _tmp4_;
		MusicMedia* _tmp5_;
		_tmp2_ = music_app_get_player ();
		_tmp3_ = _tmp2_;
		_tmp4_ = music_playback_manager_get_current_media (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_ != NULL) {
			MusicPlaybackManager* _tmp6_;
			MusicPlaybackManager* _tmp7_;
			MusicMedia* _tmp8_;
			MusicMedia* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			_tmp6_ = music_app_get_player ();
			_tmp7_ = _tmp6_;
			_tmp8_ = music_playback_manager_get_current_media (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = music_media_get_resume_pos (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp1_ = music_playback_get_position ((MusicPlayback*) self) >= (((gint64) (_tmp11_ - 1)) * 1000000000);
		} else {
			_tmp1_ = FALSE;
		}
		_tmp0_ = _tmp1_;
	}
	if (_tmp0_) {
		self->set_resume_pos = TRUE;
		g_signal_emit_by_name ((MusicPlayback*) self, "current-position-update", music_playback_get_position ((MusicPlayback*) self));
	} else {
		MusicPlaybackManager* _tmp12_;
		MusicPlaybackManager* _tmp13_;
		MusicMedia* _tmp14_;
		MusicMedia* _tmp15_;
		_tmp12_ = music_app_get_player ();
		_tmp13_ = _tmp12_;
		_tmp14_ = music_playback_manager_get_current_media (_tmp13_);
		_tmp15_ = _tmp14_;
		if (_tmp15_ != NULL) {
			MusicPipeline* _tmp16_;
			GstElement* _tmp17_;
			MusicPlaybackManager* _tmp18_;
			MusicPlaybackManager* _tmp19_;
			MusicMedia* _tmp20_;
			MusicMedia* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			_tmp16_ = self->priv->pipe;
			_tmp17_ = _tmp16_->playbin;
			_tmp18_ = music_app_get_player ();
			_tmp19_ = _tmp18_;
			_tmp20_ = music_playback_manager_get_current_media (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = music_media_get_resume_pos (_tmp21_);
			_tmp23_ = _tmp22_;
			gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
		}
	}
	result = TRUE;
	return result;
}

static void
music_streamer_real_play (MusicPlayback* base)
{
	MusicStreamer * self;
	self = (MusicStreamer*) base;
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
}

static void
music_streamer_real_pause (MusicPlayback* base)
{
	MusicStreamer * self;
	self = (MusicStreamer*) base;
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PAUSED);
}

static void
music_streamer_real_set_state (MusicPlayback* base,
                               GstState s)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (MusicStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_set_state (_tmp1_, s);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp7_);
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp7_);
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
music_streamer_real_set_media (MusicPlayback* base,
                               MusicMedia* media)
{
	MusicStreamer * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	MusicPipeline* _tmp3_;
	GstElement* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GValue _tmp9_ = {0};
	MusicPlaybackManager* _tmp10_;
	MusicPlaybackManager* _tmp11_;
	MusicMedia* _tmp12_;
	MusicMedia* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	MusicPipeline* _tmp16_;
	GstElement* _tmp17_;
	MusicPlaybackManager* _tmp18_;
	MusicPlaybackManager* _tmp19_;
	MusicMedia* _tmp20_;
	MusicMedia* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	self = (MusicStreamer*) base;
	g_return_if_fail (media != NULL);
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_READY);
	_tmp0_ = music_media_get_uri (media);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	g_debug ("Streamer.vala:87: set uri to %s\n", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->pipe;
	_tmp4_ = _tmp3_->playbin;
	_tmp5_ = music_media_get_uri (media);
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_;
	_tmp8_ = string_replace (_tmp7_, "#", "%23");
	g_value_init (&_tmp9_, G_TYPE_STRING);
	g_value_take_string (&_tmp9_, _tmp8_);
	g_object_set_property ((GObject*) _tmp4_, "uri", &_tmp9_);
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
	_g_free0 (_tmp7_);
	music_playback_set_state ((MusicPlayback*) self, GST_STATE_PLAYING);
	_tmp10_ = music_app_get_player ();
	_tmp11_ = _tmp10_;
	_tmp12_ = music_playback_manager_get_current_media (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = music_media_get_resume_pos (_tmp13_);
	_tmp15_ = _tmp14_;
	g_debug ("Streamer.vala:93: setURI seeking to %d\n", _tmp15_);
	_tmp16_ = self->priv->pipe;
	_tmp17_ = _tmp16_->playbin;
	_tmp18_ = music_app_get_player ();
	_tmp19_ = _tmp18_;
	_tmp20_ = music_playback_manager_get_current_media (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = music_media_get_resume_pos (_tmp21_);
	_tmp23_ = _tmp22_;
	gst_element_seek_simple (_tmp17_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp23_) * 1000000000);
	music_playback_play ((MusicPlayback*) self);
}

static void
music_streamer_real_set_position (MusicPlayback* base,
                                  gint64 pos)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	self = (MusicStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, pos, GST_SEEK_TYPE_NONE, music_playback_get_duration ((MusicPlayback*) self));
}

static gint64
music_streamer_real_get_position (MusicPlayback* base)
{
	MusicStreamer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result = 0LL;
	self = (MusicStreamer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_position (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}

static gint64
music_streamer_real_get_duration (MusicPlayback* base)
{
	MusicStreamer * self;
	gint64 rv = 0LL;
	GstFormat f = 0;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gint64 result = 0LL;
	self = (MusicStreamer*) base;
	rv = (gint64) 0;
	f = GST_FORMAT_TIME;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
	rv = _tmp2_;
	result = rv;
	return result;
}

static void
music_streamer_real_set_volume (MusicPlayback* base,
                                gdouble val)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	GstElement* _tmp1_;
	GValue _tmp2_ = {0};
	self = (MusicStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->playbin;
	g_value_init (&_tmp2_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp2_, val);
	g_object_set_property ((GObject*) _tmp1_, "volume", &_tmp2_);
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
}

static gdouble
music_streamer_real_get_volume (MusicPlayback* base)
{
	MusicStreamer * self;
	GValue val = {0};
	GValue _tmp0_ = {0};
	MusicPipeline* _tmp1_;
	GstElement* _tmp2_;
	GValue _tmp3_;
	gdouble result = 0.0;
	self = (MusicStreamer*) base;
	g_value_init (&_tmp0_, G_TYPE_DOUBLE);
	val = _tmp0_;
	_tmp1_ = self->priv->pipe;
	_tmp2_ = _tmp1_->playbin;
	g_object_get_property ((GObject*) _tmp2_, "volume", &val);
	_tmp3_ = val;
	result = g_value_get_double (&_tmp3_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return result;
}

static void
music_streamer_real_enable_equalizer (MusicPlayback* base)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	self = (MusicStreamer*) base;
	_tmp0_ = self->priv->pipe;
	music_pipeline_enable_equalizer (_tmp0_);
}

static void
music_streamer_real_disable_equalizer (MusicPlayback* base)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	self = (MusicStreamer*) base;
	_tmp0_ = self->priv->pipe;
	music_pipeline_disable_equalizer (_tmp0_);
}

static void
music_streamer_real_set_equalizer_gain (MusicPlayback* base,
                                        gint index,
                                        gint val)
{
	MusicStreamer * self;
	MusicPipeline* _tmp0_;
	MusicEqualizer* _tmp1_;
	self = (MusicStreamer*) base;
	_tmp0_ = self->priv->pipe;
	_tmp1_ = _tmp0_->eq;
	music_equalizer_set_gain (_tmp1_, index, (gdouble) val);
}

static gboolean
music_streamer_bus_callback (MusicStreamer* self,
                             GstBus* bus,
                             GstMessage* message)
{
	GstMessageType _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bus != NULL, FALSE);
	g_return_val_if_fail (message != NULL, FALSE);
	_tmp0_ = message->type;
	switch (_tmp0_) {
		case GST_MESSAGE_ERROR:
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gst_message_parse_error (message, &_tmp1_, &_tmp2_);
			_g_error_free0 (err);
			err = _tmp1_;
			_g_free0 (debug);
			debug = _tmp2_;
			_tmp3_ = err;
			_tmp4_ = _tmp3_->message;
			g_warning ("Streamer.vala:154: Error: %s\n", _tmp4_);
			g_signal_emit_by_name ((MusicPlayback*) self, "error-occured");
			_g_free0 (debug);
			_g_error_free0 (err);
			break;
		}
		case GST_MESSAGE_ELEMENT:
		{
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			GstStructure* _tmp7_;
			_tmp7_ = gst_message_get_structure (message);
			if (_tmp7_ != NULL) {
				_tmp6_ = gst_is_missing_plugin_message (message);
			} else {
				_tmp6_ = FALSE;
			}
			if (_tmp6_) {
				gboolean _tmp8_ = FALSE;
				MusicInstallGstreamerPluginsDialog* _tmp9_;
				_tmp9_ = self->priv->dialog;
				if (_tmp9_ == NULL) {
					_tmp8_ = TRUE;
				} else {
					MusicInstallGstreamerPluginsDialog* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					_tmp10_ = self->priv->dialog;
					_tmp11_ = gtk_widget_get_visible ((GtkWidget*) _tmp10_);
					_tmp12_ = _tmp11_;
					_tmp8_ = !_tmp12_;
				}
				_tmp5_ = _tmp8_;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				MusicInstallGstreamerPluginsDialog* _tmp13_;
				_tmp13_ = music_install_gstreamer_plugins_dialog_new (message);
				g_object_ref_sink (_tmp13_);
				_g_object_unref0 (self->priv->dialog);
				self->priv->dialog = _tmp13_;
			}
			break;
		}
		case GST_MESSAGE_EOS:
		{
			g_signal_emit_by_name ((MusicPlayback*) self, "end-of-stream");
			break;
		}
		case GST_MESSAGE_STATE_CHANGED:
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp14_ = 0;
			GstState _tmp15_ = 0;
			GstState _tmp16_ = 0;
			GstState _tmp17_;
			gst_message_parse_state_changed (message, &_tmp14_, &_tmp15_, &_tmp16_);
			oldstate = _tmp14_;
			newstate = _tmp15_;
			pending = _tmp16_;
			_tmp17_ = newstate;
			if (_tmp17_ != GST_STATE_PLAYING) {
				break;
			}
			break;
		}
		case GST_MESSAGE_TAG:
		{
			GstTagList* tag_list = NULL;
			GstTagList* _tmp18_ = NULL;
			GstTagList* _tmp19_;
			gst_message_parse_tag (message, &_tmp18_);
			_gst_tag_list_unref0 (tag_list);
			tag_list = _tmp18_;
			_tmp19_ = tag_list;
			if (_tmp19_ != NULL) {
				GstTagList* _tmp20_;
				_tmp20_ = tag_list;
				if (gst_tag_list_get_tag_size (_tmp20_, GST_TAG_TITLE) > ((guint) 0)) {
					gchar* title = NULL;
					gchar* _tmp21_;
					GstTagList* _tmp22_;
					gchar* _tmp23_ = NULL;
					_tmp21_ = g_strdup ("");
					title = _tmp21_;
					_tmp22_ = tag_list;
					gst_tag_list_get_string (_tmp22_, GST_TAG_TITLE, &_tmp23_);
					_g_free0 (title);
					title = _tmp23_;
					_g_free0 (title);
				}
			}
			_gst_tag_list_unref0 (tag_list);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}

static void
music_streamer_class_init (MusicStreamerClass * klass,
                           gpointer klass_data)
{
	music_streamer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicStreamer_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_streamer_finalize;
}

static void
music_streamer_music_playback_interface_init (MusicPlaybackIface * iface,
                                              gpointer iface_data)
{
	music_streamer_music_playback_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_supported_uri = (GeeCollection* (*) (MusicPlayback*)) music_streamer_real_get_supported_uri;
	iface->update_position = (gboolean (*) (MusicPlayback*)) music_streamer_real_update_position;
	iface->play = (void (*) (MusicPlayback*)) music_streamer_real_play;
	iface->pause = (void (*) (MusicPlayback*)) music_streamer_real_pause;
	iface->set_state = (void (*) (MusicPlayback*, GstState)) music_streamer_real_set_state;
	iface->set_media = (void (*) (MusicPlayback*, MusicMedia*)) music_streamer_real_set_media;
	iface->set_position = (void (*) (MusicPlayback*, gint64)) music_streamer_real_set_position;
	iface->get_position = (gint64 (*) (MusicPlayback*)) music_streamer_real_get_position;
	iface->get_duration = (gint64 (*) (MusicPlayback*)) music_streamer_real_get_duration;
	iface->set_volume = (void (*) (MusicPlayback*, gdouble)) music_streamer_real_set_volume;
	iface->get_volume = (gdouble (*) (MusicPlayback*)) music_streamer_real_get_volume;
	iface->enable_equalizer = (void (*) (MusicPlayback*)) music_streamer_real_enable_equalizer;
	iface->disable_equalizer = (void (*) (MusicPlayback*)) music_streamer_real_disable_equalizer;
	iface->set_equalizer_gain = (void (*) (MusicPlayback*, gint, gint)) music_streamer_real_set_equalizer_gain;
}

static void
music_streamer_instance_init (MusicStreamer * self,
                              gpointer klass)
{
	self->priv = music_streamer_get_instance_private (self);
}

static void
music_streamer_finalize (GObject * obj)
{
	MusicStreamer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_STREAMER, MusicStreamer);
	_g_object_unref0 (self->priv->pipe);
	_g_object_unref0 (self->priv->dialog);
	_g_object_unref0 (self->cdda);
	G_OBJECT_CLASS (music_streamer_parent_class)->finalize (obj);
}

static GType
music_streamer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicStreamerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_streamer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicStreamer), 0, (GInstanceInitFunc) music_streamer_instance_init, NULL };
	static const GInterfaceInfo music_playback_info = { (GInterfaceInitFunc) music_streamer_music_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_streamer_type_id;
	music_streamer_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicStreamer", &g_define_type_info, 0);
	g_type_add_interface_static (music_streamer_type_id, MUSIC_TYPE_PLAYBACK, &music_playback_info);
	MusicStreamer_private_offset = g_type_add_instance_private (music_streamer_type_id, sizeof (MusicStreamerPrivate));
	return music_streamer_type_id;
}

GType
music_streamer_get_type (void)
{
	static volatile gsize music_streamer_type_id__volatile = 0;
	if (g_once_init_enter (&music_streamer_type_id__volatile)) {
		GType music_streamer_type_id;
		music_streamer_type_id = music_streamer_get_type_once ();
		g_once_init_leave (&music_streamer_type_id__volatile, music_streamer_type_id);
	}
	return music_streamer_type_id__volatile;
}

