/* DeviceView.c generated by valac 0.48.17, the Vala compiler
 * generated from DeviceView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#define MUSIC_TYPE_DEVICE_VIEW (music_device_view_get_type ())
#define MUSIC_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView))
#define MUSIC_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_DEVICE_VIEW, MusicDeviceViewClass))
#define MUSIC_IS_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_DEVICE_VIEW))
#define MUSIC_IS_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_DEVICE_VIEW))
#define MUSIC_DEVICE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_DEVICE_VIEW, MusicDeviceViewClass))

typedef struct _MusicDeviceView MusicDeviceView;
typedef struct _MusicDeviceViewClass MusicDeviceViewClass;
typedef struct _MusicDeviceViewPrivate MusicDeviceViewPrivate;

#define MUSIC_TYPE_DEVICE_PREFERENCES (music_device_preferences_get_type ())
#define MUSIC_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferences))
#define MUSIC_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferencesClass))
#define MUSIC_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_DEVICE_PREFERENCES))
#define MUSIC_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_DEVICE_PREFERENCES))
#define MUSIC_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_DEVICE_PREFERENCES, MusicDevicePreferencesClass))

typedef struct _MusicDevicePreferences MusicDevicePreferences;
typedef struct _MusicDevicePreferencesClass MusicDevicePreferencesClass;
enum  {
	MUSIC_DEVICE_VIEW_0_PROPERTY,
	MUSIC_DEVICE_VIEW_DEVICE_PROPERTY,
	MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY,
	MUSIC_DEVICE_VIEW_NUM_PROPERTIES
};
static GParamSpec* music_device_view_properties[MUSIC_DEVICE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block22Data Block22Data;

#define MUSIC_TYPE_DEVICE_SUMMARY_WIDGET (music_device_summary_widget_get_type ())
#define MUSIC_DEVICE_SUMMARY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_DEVICE_SUMMARY_WIDGET, MusicDeviceSummaryWidget))
#define MUSIC_DEVICE_SUMMARY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_DEVICE_SUMMARY_WIDGET, MusicDeviceSummaryWidgetClass))
#define MUSIC_IS_DEVICE_SUMMARY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_DEVICE_SUMMARY_WIDGET))
#define MUSIC_IS_DEVICE_SUMMARY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_DEVICE_SUMMARY_WIDGET))
#define MUSIC_DEVICE_SUMMARY_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_DEVICE_SUMMARY_WIDGET, MusicDeviceSummaryWidgetClass))

typedef struct _MusicDeviceSummaryWidget MusicDeviceSummaryWidget;
typedef struct _MusicDeviceSummaryWidgetClass MusicDeviceSummaryWidgetClass;

struct _MusicDeviceView {
	GtkGrid parent_instance;
	MusicDeviceViewPrivate * priv;
};

struct _MusicDeviceViewClass {
	GtkGridClass parent_class;
};

struct _MusicDeviceViewPrivate {
	MusicDevice* _device;
	MusicDevicePreferences* _preferences;
};

struct _Block22Data {
	int _ref_count_;
	MusicDeviceView* self;
	GtkLabel* infobar_label;
	GtkInfoBar* infobar;
	gulong connector;
};

static gint MusicDeviceView_private_offset;
static gpointer music_device_view_parent_class = NULL;

GType music_device_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicDeviceView, g_object_unref)
GType music_device_preferences_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicDevicePreferences, g_object_unref)
MusicDeviceView* music_device_view_new (MusicDevice* device,
                                        MusicDevicePreferences* preferences);
MusicDeviceView* music_device_view_construct (GType object_type,
                                              MusicDevice* device,
                                              MusicDevicePreferences* preferences);
MusicDevice* music_device_view_get_device (MusicDeviceView* self);
static void music_device_view_set_device (MusicDeviceView* self,
                                   MusicDevice* value);
MusicDevicePreferences* music_device_view_get_preferences (MusicDeviceView* self);
static void music_device_view_set_preferences (MusicDeviceView* self,
                                        MusicDevicePreferences* value);
static GObject * music_device_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
GType music_device_summary_widget_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicDeviceSummaryWidget, g_object_unref)
MusicDeviceSummaryWidget* music_device_summary_widget_new (MusicDevice* device,
                                                           MusicDevicePreferences* preferences);
MusicDeviceSummaryWidget* music_device_summary_widget_construct (GType object_type,
                                                                 MusicDevice* device,
                                                                 MusicDevicePreferences* preferences);
static void _music_device_view___lambda116_ (MusicDeviceView* self);
static void __music_device_view___lambda116__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                                                    gpointer self);
static void _music_device_view___lambda117_ (Block22Data* _data22_);
static void __music_device_view___lambda117__music_device_device_unmounted (MusicDevice* _sender,
                                                                     gpointer self);
static void _music_device_view___lambda118_ (Block22Data* _data22_,
                                      const gchar* label,
                                      GtkMessageType message_type);
static void __music_device_view___lambda118__music_device_infobar_message (MusicDevice* _sender,
                                                                    const gchar* label,
                                                                    GtkMessageType message_type,
                                                                    gpointer self);
static void _music_device_view___lambda119_ (Block22Data* _data22_,
                                      GtkInfoBar* _self_,
                                      gint response);
static void __music_device_view___lambda119__gtk_info_bar_response (GtkInfoBar* _sender,
                                                             gint response_id,
                                                             gpointer self);
gboolean music_device_preferences_get_sync_when_mounted (MusicDevicePreferences* self);
void music_device_summary_widget_sync_clicked (MusicDeviceSummaryWidget* self);
static void music_device_view_finalize (GObject * obj);
static GType music_device_view_get_type_once (void);
static void _vala_music_device_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_music_device_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
music_device_view_get_instance_private (MusicDeviceView* self)
{
	return G_STRUCT_MEMBER_P (self, MusicDeviceView_private_offset);
}

MusicDeviceView*
music_device_view_construct (GType object_type,
                             MusicDevice* device,
                             MusicDevicePreferences* preferences)
{
	MusicDeviceView * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (preferences != NULL, NULL);
	self = (MusicDeviceView*) g_object_new (object_type, "device", device, "preferences", preferences, NULL);
	return self;
}

MusicDeviceView*
music_device_view_new (MusicDevice* device,
                       MusicDevicePreferences* preferences)
{
	return music_device_view_construct (MUSIC_TYPE_DEVICE_VIEW, device, preferences);
}

MusicDevice*
music_device_view_get_device (MusicDeviceView* self)
{
	MusicDevice* result;
	MusicDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_device_view_set_device (MusicDeviceView* self,
                              MusicDevice* value)
{
	MusicDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_device_view_get_device (self);
	if (old_value != value) {
		MusicDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_device_view_properties[MUSIC_DEVICE_VIEW_DEVICE_PROPERTY]);
	}
}

MusicDevicePreferences*
music_device_view_get_preferences (MusicDeviceView* self)
{
	MusicDevicePreferences* result;
	MusicDevicePreferences* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_preferences;
	result = _tmp0_;
	return result;
}

static void
music_device_view_set_preferences (MusicDeviceView* self,
                                   MusicDevicePreferences* value)
{
	MusicDevicePreferences* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_device_view_get_preferences (self);
	if (old_value != value) {
		MusicDevicePreferences* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_preferences);
		self->priv->_preferences = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_device_view_properties[MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY]);
	}
}

static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
	g_atomic_int_inc (&_data22_->_ref_count_);
	return _data22_;
}

static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
		MusicDeviceView* self;
		self = _data22_->self;
		_g_object_unref0 (_data22_->infobar);
		_g_object_unref0 (_data22_->infobar_label);
		_g_object_unref0 (self);
		g_slice_free (Block22Data, _data22_);
	}
}

static void
_music_device_view___lambda116_ (MusicDeviceView* self)
{
	MusicDevice* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* _tmp2_;
	gboolean _tmp3_;
	_tmp0_ = self->priv->_device;
	_tmp1_ = music_device_get_library (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = music_library_doing_file_operations (_tmp2_);
	_g_object_unref0 (_tmp2_);
	if (_tmp3_) {
		MusicNotificationManager* _tmp4_;
		MusicNotificationManager* _tmp5_;
		_tmp4_ = music_notification_manager_get_default ();
		_tmp5_ = _tmp4_;
		g_signal_emit_by_name (_tmp5_, "show-alert", _ ("Cancelling…"), _ ("Device operation has been cancelled and will stop after this media."));
		_g_object_unref0 (_tmp5_);
	}
}

static void
__music_device_view___lambda116__music_notification_manager_progress_canceled (MusicNotificationManager* _sender,
                                                                               gpointer self)
{
	_music_device_view___lambda116_ ((MusicDeviceView*) self);
}

static void
_music_device_view___lambda117_ (Block22Data* _data22_)
{
	MusicDeviceView* self;
	MusicDevice* _tmp0_;
	self = _data22_->self;
	g_message ("DeviceView.vala:71: device unmounted\n");
	_tmp0_ = self->priv->_device;
	g_signal_handler_disconnect ((GObject*) _tmp0_, _data22_->connector);
}

static void
__music_device_view___lambda117__music_device_device_unmounted (MusicDevice* _sender,
                                                                gpointer self)
{
	_music_device_view___lambda117_ (self);
}

static void
_music_device_view___lambda118_ (Block22Data* _data22_,
                                 const gchar* label,
                                 GtkMessageType message_type)
{
	MusicDeviceView* self;
	GtkLabel* _tmp0_;
	GtkInfoBar* _tmp1_;
	GtkInfoBar* _tmp2_;
	self = _data22_->self;
	g_return_if_fail (label != NULL);
	_tmp0_ = _data22_->infobar_label;
	gtk_label_set_label (_tmp0_, label);
	_tmp1_ = _data22_->infobar;
	gtk_info_bar_set_message_type (_tmp1_, message_type);
	_tmp2_ = _data22_->infobar;
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
}

static void
__music_device_view___lambda118__music_device_infobar_message (MusicDevice* _sender,
                                                               const gchar* label,
                                                               GtkMessageType message_type,
                                                               gpointer self)
{
	_music_device_view___lambda118_ (self, label, message_type);
}

static void
_music_device_view___lambda119_ (Block22Data* _data22_,
                                 GtkInfoBar* _self_,
                                 gint response)
{
	MusicDeviceView* self;
	GtkInfoBar* _tmp0_;
	self = _data22_->self;
	g_return_if_fail (_self_ != NULL);
	_tmp0_ = _data22_->infobar;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
}

static void
__music_device_view___lambda119__gtk_info_bar_response (GtkInfoBar* _sender,
                                                        gint response_id,
                                                        gpointer self)
{
	_music_device_view___lambda119_ (self, _sender, response_id);
}

static GObject *
music_device_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicDeviceView * self;
	Block22Data* _data22_;
	GtkLabel* _tmp0_;
	GtkInfoBar* _tmp1_;
	GtkInfoBar* _tmp2_;
	GtkInfoBar* _tmp3_;
	GtkInfoBar* _tmp4_;
	GtkContainer* _tmp5_;
	GtkLabel* _tmp6_;
	MusicDeviceSummaryWidget* summary = NULL;
	MusicDevice* _tmp7_;
	MusicDevicePreferences* _tmp8_;
	MusicDeviceSummaryWidget* _tmp9_;
	GtkInfoBar* _tmp10_;
	GtkWidget* custom_view = NULL;
	MusicDevice* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkInfoBar* _tmp16_;
	MusicNotificationManager* _tmp17_;
	MusicNotificationManager* _tmp18_;
	gulong _tmp19_;
	gulong _tmp20_;
	MusicDevice* _tmp21_;
	MusicDevice* _tmp22_;
	GtkInfoBar* _tmp23_;
	MusicDevicePreferences* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	parent_class = G_OBJECT_CLASS (music_device_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView);
	_data22_ = g_slice_new0 (Block22Data);
	_data22_->_ref_count_ = 1;
	_data22_->self = g_object_ref (self);
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp0_);
	_data22_->infobar_label = _tmp0_;
	_tmp1_ = (GtkInfoBar*) gtk_info_bar_new ();
	g_object_ref_sink (_tmp1_);
	_data22_->infobar = _tmp1_;
	_tmp2_ = _data22_->infobar;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
	_tmp3_ = _data22_->infobar;
	gtk_info_bar_add_button (_tmp3_, _ ("Close"), 0);
	_tmp4_ = _data22_->infobar;
	_tmp5_ = gtk_info_bar_get_content_area (_tmp4_);
	_tmp6_ = _data22_->infobar_label;
	gtk_container_add (_tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = self->priv->_device;
	_tmp8_ = self->priv->_preferences;
	_tmp9_ = music_device_summary_widget_new (_tmp7_, _tmp8_);
	g_object_ref_sink (_tmp9_);
	summary = _tmp9_;
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp10_ = _data22_->infobar;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp10_, 0, 0, 1, 1);
	_tmp11_ = self->priv->_device;
	_tmp12_ = music_device_get_custom_view (_tmp11_);
	custom_view = _tmp12_;
	_tmp13_ = custom_view;
	if (_tmp13_ != NULL) {
		GtkWidget* _tmp14_;
		_tmp14_ = custom_view;
		gtk_grid_attach ((GtkGrid*) self, _tmp14_, 0, 1, 1, 1);
	} else {
		MusicDeviceSummaryWidget* _tmp15_;
		_tmp15_ = summary;
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp15_, 0, 1, 1, 1);
	}
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp16_ = _data22_->infobar;
	gtk_widget_hide ((GtkWidget*) _tmp16_);
	_tmp17_ = music_notification_manager_get_default ();
	_tmp18_ = _tmp17_;
	_tmp19_ = g_signal_connect_object (_tmp18_, "progress-canceled", (GCallback) __music_device_view___lambda116__music_notification_manager_progress_canceled, self, 0);
	_tmp20_ = _tmp19_;
	_g_object_unref0 (_tmp18_);
	_data22_->connector = _tmp20_;
	_tmp21_ = self->priv->_device;
	g_signal_connect_data (_tmp21_, "device-unmounted", (GCallback) __music_device_view___lambda117__music_device_device_unmounted, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
	_tmp22_ = self->priv->_device;
	g_signal_connect_data (_tmp22_, "infobar-message", (GCallback) __music_device_view___lambda118__music_device_infobar_message, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
	_tmp23_ = _data22_->infobar;
	g_signal_connect_data (_tmp23_, "response", (GCallback) __music_device_view___lambda119__gtk_info_bar_response, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
	_tmp24_ = self->priv->_preferences;
	_tmp25_ = music_device_preferences_get_sync_when_mounted (_tmp24_);
	_tmp26_ = _tmp25_;
	if (_tmp26_) {
		MusicDeviceSummaryWidget* _tmp27_;
		_tmp27_ = summary;
		music_device_summary_widget_sync_clicked (_tmp27_);
	}
	_g_object_unref0 (custom_view);
	_g_object_unref0 (summary);
	block22_data_unref (_data22_);
	_data22_ = NULL;
	return obj;
}

static void
music_device_view_class_init (MusicDeviceViewClass * klass,
                              gpointer klass_data)
{
	music_device_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicDeviceView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_device_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_device_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_device_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_device_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_VIEW_DEVICE_PROPERTY, music_device_view_properties[MUSIC_DEVICE_VIEW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", MUSIC_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY, music_device_view_properties[MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY] = g_param_spec_object ("preferences", "preferences", "preferences", MUSIC_TYPE_DEVICE_PREFERENCES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
music_device_view_instance_init (MusicDeviceView * self,
                                 gpointer klass)
{
	self->priv = music_device_view_get_instance_private (self);
}

static void
music_device_view_finalize (GObject * obj)
{
	MusicDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->_preferences);
	G_OBJECT_CLASS (music_device_view_parent_class)->finalize (obj);
}

static GType
music_device_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicDeviceViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_device_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicDeviceView), 0, (GInstanceInitFunc) music_device_view_instance_init, NULL };
	GType music_device_view_type_id;
	music_device_view_type_id = g_type_register_static (gtk_grid_get_type (), "MusicDeviceView", &g_define_type_info, 0);
	MusicDeviceView_private_offset = g_type_add_instance_private (music_device_view_type_id, sizeof (MusicDeviceViewPrivate));
	return music_device_view_type_id;
}

GType
music_device_view_get_type (void)
{
	static volatile gsize music_device_view_type_id__volatile = 0;
	if (g_once_init_enter (&music_device_view_type_id__volatile)) {
		GType music_device_view_type_id;
		music_device_view_type_id = music_device_view_get_type_once ();
		g_once_init_leave (&music_device_view_type_id__volatile, music_device_view_type_id);
	}
	return music_device_view_type_id__volatile;
}

static void
_vala_music_device_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	MusicDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView);
	switch (property_id) {
		case MUSIC_DEVICE_VIEW_DEVICE_PROPERTY:
		g_value_set_object (value, music_device_view_get_device (self));
		break;
		case MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY:
		g_value_set_object (value, music_device_view_get_preferences (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_device_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	MusicDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_DEVICE_VIEW, MusicDeviceView);
	switch (property_id) {
		case MUSIC_DEVICE_VIEW_DEVICE_PROPERTY:
		music_device_view_set_device (self, g_value_get_object (value));
		break;
		case MUSIC_DEVICE_VIEW_PREFERENCES_PROPERTY:
		music_device_view_set_preferences (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

