/* AudioPlayerDevice.c generated by valac 0.48.17, the Vala compiler
 * generated from AudioPlayerDevice.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "music-lib.h"
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE (music_plugins_audio_player_device_get_type ())
#define MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, MusicPluginsAudioPlayerDevice))
#define MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, MusicPluginsAudioPlayerDeviceClass))
#define MUSIC_PLUGINS_IS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define MUSIC_PLUGINS_IS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, MusicPluginsAudioPlayerDeviceClass))

typedef struct _MusicPluginsAudioPlayerDevice MusicPluginsAudioPlayerDevice;
typedef struct _MusicPluginsAudioPlayerDeviceClass MusicPluginsAudioPlayerDeviceClass;
typedef struct _MusicPluginsAudioPlayerDevicePrivate MusicPluginsAudioPlayerDevicePrivate;

#define MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY (music_plugins_audio_player_library_get_type ())
#define MUSIC_PLUGINS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, MusicPluginsAudioPlayerLibrary))
#define MUSIC_PLUGINS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, MusicPluginsAudioPlayerLibraryClass))
#define MUSIC_PLUGINS_IS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define MUSIC_PLUGINS_IS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define MUSIC_PLUGINS_AUDIO_PLAYER_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, MusicPluginsAudioPlayerLibraryClass))

typedef struct _MusicPluginsAudioPlayerLibrary MusicPluginsAudioPlayerLibrary;
typedef struct _MusicPluginsAudioPlayerLibraryClass MusicPluginsAudioPlayerLibraryClass;
enum  {
	MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_0_PROPERTY,
	MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES
};
static GParamSpec* music_plugins_audio_player_device_properties[MUSIC_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MusicPluginsAudioPlayerLibraryPrivate MusicPluginsAudioPlayerLibraryPrivate;
typedef struct _MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData;

struct _MusicPluginsAudioPlayerDevice {
	GObject parent_instance;
	MusicPluginsAudioPlayerDevicePrivate * priv;
};

struct _MusicPluginsAudioPlayerDeviceClass {
	GObjectClass parent_class;
};

struct _MusicPluginsAudioPlayerDevicePrivate {
	GMount* mount;
	GIcon* icon;
	gboolean is_androphone;
	GeeLinkedList* music_folders;
	MusicPluginsAudioPlayerLibrary* library;
};

struct _MusicPluginsAudioPlayerLibrary {
	MusicLibrary parent_instance;
	MusicPluginsAudioPlayerLibraryPrivate * priv;
	gint medias_rowid;
	gint playlists_rowid;
	gint smartplaylists_rowid;
	MusicGStreamerTagger* tagger;
};

struct _MusicPluginsAudioPlayerLibraryClass {
	MusicLibraryClass parent_class;
};

struct _MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicPluginsAudioPlayerDevice* self;
	GeeLinkedList* _tmp0_;
	GMount* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GFile* file;
	GMount* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFileInputStream* _tmp18_;
	GFile* _tmp19_;
	GFileInputStream* _tmp20_;
	GDataInputStream* dis;
	GDataInputStream* _tmp21_;
	gchar* line;
	gchar* _tmp22_;
	GDataInputStream* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* folders_unparsed;
	const gchar* _tmp28_;
	gchar** _tmp29_;
	gchar** _tmp30_;
	gchar** _tmp31_;
	gint _tmp31__length1;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	gchar** _tmp36_;
	gchar** _tmp37_;
	gchar** folder_collection;
	gint folder_collection_length1;
	gint _folder_collection_size_;
	gint folder_it;
	gchar* _tmp38_;
	gchar* folder;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	GeeLinkedList* _tmp41_;
	GMount* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	GError* e;
	FILE* _tmp52_;
	GError* _tmp53_;
	const gchar* _tmp54_;
	GeeLinkedList* files;
	GeeLinkedList* _tmp55_;
	gint items;
	GeeLinkedList* _folder_list;
	GeeLinkedList* _tmp56_;
	GeeLinkedList* _tmp57_;
	gint _folder_size;
	GeeLinkedList* _tmp58_;
	gint _tmp59_;
	gint _tmp60_;
	gint _folder_index;
	gint _tmp61_;
	gint _tmp62_;
	gchar* _vala1_folder;
	GeeLinkedList* _tmp63_;
	gpointer _tmp64_;
	GFile* music_folder_file;
	const gchar* _tmp65_;
	GFile* _tmp66_;
	GFile* _tmp67_;
	GeeLinkedList* _tmp68_;
	MusicPluginsAudioPlayerLibrary* _tmp69_;
	MusicGStreamerTagger* _tmp70_;
	GeeLinkedList* _tmp71_;
	GeeLinkedList* _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	MusicPluginsAudioPlayerLibrary* _tmp75_;
	GError* _inner_error0_;
};

static gint MusicPluginsAudioPlayerDevice_private_offset;
static gpointer music_plugins_audio_player_device_parent_class = NULL;
static MusicDeviceIface * music_plugins_audio_player_device_music_device_parent_iface = NULL;
static GType music_plugins_audio_player_device_type_id = 0;

GType music_plugins_audio_player_device_register_type (GTypeModule * module);
GType music_plugins_audio_player_device_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPluginsAudioPlayerDevice, g_object_unref)
GType music_plugins_audio_player_library_register_type (GTypeModule * module);
GType music_plugins_audio_player_library_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPluginsAudioPlayerLibrary, g_object_unref)
MusicPluginsAudioPlayerDevice* music_plugins_audio_player_device_new (GMount* mount,
                                                                      gboolean is_androphone);
MusicPluginsAudioPlayerDevice* music_plugins_audio_player_device_construct (GType object_type,
                                                                            GMount* mount,
                                                                            gboolean is_androphone);
MusicPluginsAudioPlayerLibrary* music_plugins_audio_player_library_new (MusicPluginsAudioPlayerDevice* device);
MusicPluginsAudioPlayerLibrary* music_plugins_audio_player_library_construct (GType object_type,
                                                                              MusicPluginsAudioPlayerDevice* device);
static void music_plugins_audio_player_device_real_finish_initialization (MusicDevice* base);
static void __lambda8_ (MusicPluginsAudioPlayerDevice* self);
static void ___lambda8__music_device_device_unmounted (MusicDevice* _sender,
                                                gpointer self);
static void music_plugins_audio_player_device_finish_initialization_async (MusicPluginsAudioPlayerDevice* self,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static void music_plugins_audio_player_device_finish_initialization_finish (MusicPluginsAudioPlayerDevice* self,
                                                                     GAsyncResult* _res_);
static gboolean music_plugins_audio_player_device_real_start_initialization (MusicDevice* base);
static void music_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data);
static gboolean music_plugins_audio_player_device_finish_initialization_async_co (MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_);
void music_plugins_audio_player_library_queue_finished (MusicPluginsAudioPlayerLibrary* self);
static gboolean __lambda9_ (MusicPluginsAudioPlayerDevice* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static MusicLibrary* music_plugins_audio_player_device_real_get_library (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_empty_device_title (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_empty_device_description (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_content_type (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_display_name (MusicDevice* base);
static void music_plugins_audio_player_device_real_set_display_name (MusicDevice* base,
                                                              const gchar* name);
static gchar* music_plugins_audio_player_device_real_get_fancy_description (MusicDevice* base);
static void music_plugins_audio_player_device_real_set_mount (MusicDevice* base,
                                                       GMount* mount);
static GMount* music_plugins_audio_player_device_real_get_mount (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_uri (MusicDevice* base);
static void music_plugins_audio_player_device_real_set_icon (MusicDevice* base,
                                                      GIcon* icon);
static GIcon* music_plugins_audio_player_device_real_get_icon (MusicDevice* base);
static guint64 music_plugins_audio_player_device_real_get_capacity (MusicDevice* base);
static gchar* music_plugins_audio_player_device_real_get_fancy_capacity (MusicDevice* base);
static guint64 music_plugins_audio_player_device_real_get_used_space (MusicDevice* base);
gchar* music_plugins_audio_player_device_get_music_folder (MusicPluginsAudioPlayerDevice* self);
static guint64 music_plugins_audio_player_device_real_get_free_space (MusicDevice* base);
static void music_plugins_audio_player_device_real_unmount (MusicDevice* base);
static void music_plugins_audio_player_device_real_eject (MusicDevice* base);
static void music_plugins_audio_player_device_real_synchronize (MusicDevice* base);
static gboolean music_plugins_audio_player_device_real_only_use_custom_view (MusicDevice* base);
static GtkWidget* music_plugins_audio_player_device_real_get_custom_view (MusicDevice* base);
static gboolean music_plugins_audio_player_device_real_read_only (MusicDevice* base);
static void music_plugins_audio_player_device_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
music_plugins_audio_player_device_get_instance_private (MusicPluginsAudioPlayerDevice* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsAudioPlayerDevice_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

MusicPluginsAudioPlayerDevice*
music_plugins_audio_player_device_construct (GType object_type,
                                             GMount* mount,
                                             gboolean is_androphone)
{
	MusicPluginsAudioPlayerDevice * self = NULL;
	GMount* _tmp0_;
	GeeLinkedList* _tmp1_;
	MusicPluginsAudioPlayerLibrary* _tmp2_;
	MusicLibrariesManager* _tmp3_;
	MusicPluginsAudioPlayerLibrary* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GThemedIcon* _tmp6_;
	g_return_val_if_fail (mount != NULL, NULL);
	self = (MusicPluginsAudioPlayerDevice*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (mount);
	_g_object_unref0 (self->priv->mount);
	self->priv->mount = _tmp0_;
	self->priv->is_androphone = is_androphone;
	_tmp1_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->music_folders);
	self->priv->music_folders = _tmp1_;
	_tmp2_ = music_plugins_audio_player_library_new (self);
	_g_object_unref0 (self->priv->library);
	self->priv->library = _tmp2_;
	_tmp3_ = music_libraries_manager;
	_tmp4_ = self->priv->library;
	music_libraries_manager_add_library (_tmp3_, (MusicLibrary*) _tmp4_);
	if (is_androphone) {
		_tmp5_ = "phone";
	} else {
		_tmp5_ = "music-player";
	}
	_tmp6_ = (GThemedIcon*) g_themed_icon_new (_tmp5_);
	_g_object_unref0 (self->priv->icon);
	self->priv->icon = (GIcon*) _tmp6_;
	return self;
}

MusicPluginsAudioPlayerDevice*
music_plugins_audio_player_device_new (GMount* mount,
                                       gboolean is_androphone)
{
	return music_plugins_audio_player_device_construct (MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, mount, is_androphone);
}

static void
__lambda8_ (MusicPluginsAudioPlayerDevice* self)
{
}

static void
___lambda8__music_device_device_unmounted (MusicDevice* _sender,
                                           gpointer self)
{
	__lambda8_ ((MusicPluginsAudioPlayerDevice*) self);
}

static void
music_plugins_audio_player_device_real_finish_initialization (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	self = (MusicPluginsAudioPlayerDevice*) base;
	g_signal_connect_object ((MusicDevice*) self, "device-unmounted", (GCallback) ___lambda8__music_device_device_unmounted, self, 0);
	music_plugins_audio_player_device_finish_initialization_async (self, NULL, NULL);
}

static gboolean
music_plugins_audio_player_device_real_start_initialization (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
	self = (MusicPluginsAudioPlayerDevice*) base;
	result = TRUE;
	return result;
}

static void
music_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data)
{
	MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData, _data_);
}

static void
music_plugins_audio_player_device_finish_initialization_async (MusicPluginsAudioPlayerDevice* self,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	MusicPluginsAudioPlayerDevice* _tmp0_;
	_data_ = g_slice_new0 (MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_plugins_audio_player_device_finish_initialization_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	music_plugins_audio_player_device_finish_initialization_async_co (_data_);
}

static void
music_plugins_audio_player_device_finish_initialization_finish (MusicPluginsAudioPlayerDevice* self,
                                                                GAsyncResult* _res_)
{
	MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gboolean
__lambda9_ (MusicPluginsAudioPlayerDevice* self)
{
	gboolean result = FALSE;
	result = FALSE;
	return result;
}

static gboolean
___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda9_ ((MusicPluginsAudioPlayerDevice*) self);
	return result;
}

static gboolean
music_plugins_audio_player_device_finish_initialization_async_co (MusicPluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (_data_->self->priv->is_androphone) {
		_data_->_tmp0_ = _data_->self->priv->music_folders;
		_data_->_tmp1_ = _data_->self->priv->mount;
		_data_->_tmp2_ = g_mount_get_root (_data_->_tmp1_);
		_data_->_tmp3_ = _data_->_tmp2_;
		_data_->_tmp4_ = g_file_get_uri (_data_->_tmp3_);
		_data_->_tmp5_ = _data_->_tmp4_;
		_data_->_tmp6_ = g_strconcat (_data_->_tmp5_, "/Music/", NULL);
		_data_->_tmp7_ = _data_->_tmp6_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp0_, _data_->_tmp7_);
		_g_free0 (_data_->_tmp7_);
		_g_free0 (_data_->_tmp5_);
		_g_object_unref0 (_data_->_tmp3_);
	} else {
		_data_->_tmp8_ = _data_->self->priv->mount;
		_data_->_tmp9_ = g_mount_get_root (_data_->_tmp8_);
		_data_->_tmp10_ = _data_->_tmp9_;
		_data_->_tmp11_ = g_file_get_uri (_data_->_tmp10_);
		_data_->_tmp12_ = _data_->_tmp11_;
		_data_->_tmp13_ = g_strconcat (_data_->_tmp12_, "/.is_audio_player", NULL);
		_data_->_tmp14_ = _data_->_tmp13_;
		_data_->_tmp15_ = g_file_new_for_uri (_data_->_tmp14_);
		_data_->_tmp16_ = _data_->_tmp15_;
		_g_free0 (_data_->_tmp14_);
		_g_free0 (_data_->_tmp12_);
		_g_object_unref0 (_data_->_tmp10_);
		_data_->file = _data_->_tmp16_;
		{
			_data_->_tmp17_ = _data_->file;
			if (g_file_query_exists (_data_->_tmp17_, NULL) == TRUE) {
				_data_->_tmp19_ = _data_->file;
				_data_->_tmp20_ = g_file_read (_data_->_tmp19_, NULL, &_data_->_inner_error0_);
				_data_->_tmp18_ = _data_->_tmp20_;
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_data_->_tmp21_ = g_data_input_stream_new ((GInputStream*) _data_->_tmp18_);
				_data_->dis = _data_->_tmp21_;
				while (TRUE) {
					_data_->_tmp23_ = _data_->dis;
					_data_->_tmp24_ = g_data_input_stream_read_line (_data_->_tmp23_, NULL, NULL, &_data_->_inner_error0_);
					_data_->_tmp22_ = _data_->_tmp24_;
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
						_g_free0 (_data_->line);
						_g_object_unref0 (_data_->dis);
						_g_object_unref0 (_data_->_tmp18_);
						goto __catch0_g_error;
					}
					_data_->_tmp25_ = _data_->_tmp22_;
					_data_->_tmp22_ = NULL;
					_g_free0 (_data_->line);
					_data_->line = _data_->_tmp25_;
					_data_->_tmp26_ = _data_->line;
					if (!(_data_->_tmp26_ != NULL)) {
						_g_free0 (_data_->_tmp22_);
						break;
					}
					_data_->_tmp27_ = _data_->line;
					if (string_contains (_data_->_tmp27_, "audio_folders=")) {
						_data_->_tmp28_ = _data_->line;
						_data_->_tmp30_ = _data_->_tmp29_ = g_strsplit (_data_->_tmp28_, "audio_folders=", 2);
						_data_->_tmp31_ = _data_->_tmp30_;
						_data_->_tmp31__length1 = _vala_array_length (_data_->_tmp29_);
						_data_->_tmp32_ = _data_->_tmp31_[1];
						_data_->_tmp33_ = g_strdup (_data_->_tmp32_);
						_data_->_tmp34_ = _data_->_tmp33_;
						_data_->_tmp31_ = (_vala_array_free (_data_->_tmp31_, _data_->_tmp31__length1, (GDestroyNotify) g_free), NULL);
						_data_->folders_unparsed = _data_->_tmp34_;
						_data_->_tmp35_ = _data_->folders_unparsed;
						_data_->_tmp37_ = _data_->_tmp36_ = g_strsplit (_data_->_tmp35_, ",", 0);
						{
							_data_->folder_collection_length1 = 0;
							_data_->_folder_collection_size_ = 0;
							_data_->folder_collection = _data_->_tmp37_;
							_data_->folder_collection_length1 = _vala_array_length (_data_->_tmp36_);
							for (_data_->folder_it = 0; _data_->folder_it < _data_->folder_collection_length1; _data_->folder_it = _data_->folder_it + 1) {
								_data_->_tmp38_ = g_strdup (_data_->folder_collection[_data_->folder_it]);
								_data_->folder = _data_->_tmp38_;
								{
									_data_->_tmp39_ = _data_->folder;
									_data_->_tmp40_ = string_replace (_data_->_tmp39_, " ", "");
									_g_free0 (_data_->folder);
									_data_->folder = _data_->_tmp40_;
									_data_->_tmp41_ = _data_->self->priv->music_folders;
									_data_->_tmp42_ = _data_->self->priv->mount;
									_data_->_tmp43_ = g_mount_get_root (_data_->_tmp42_);
									_data_->_tmp44_ = _data_->_tmp43_;
									_data_->_tmp45_ = g_file_get_uri (_data_->_tmp44_);
									_data_->_tmp46_ = _data_->_tmp45_;
									_data_->_tmp47_ = g_strconcat (_data_->_tmp46_, "/", NULL);
									_data_->_tmp48_ = _data_->_tmp47_;
									_data_->_tmp49_ = _data_->folder;
									_data_->_tmp50_ = g_strconcat (_data_->_tmp48_, _data_->_tmp49_, NULL);
									_data_->_tmp51_ = _data_->_tmp50_;
									gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp41_, _data_->_tmp51_);
									_g_free0 (_data_->_tmp51_);
									_g_free0 (_data_->_tmp48_);
									_g_free0 (_data_->_tmp46_);
									_g_object_unref0 (_data_->_tmp44_);
									_g_free0 (_data_->folder);
								}
							}
							_data_->folder_collection = (_vala_array_free (_data_->folder_collection, _data_->folder_collection_length1, (GDestroyNotify) g_free), NULL);
						}
						_g_free0 (_data_->folders_unparsed);
					}
					_g_free0 (_data_->_tmp22_);
				}
				_g_free0 (_data_->line);
				_g_object_unref0 (_data_->dis);
				_g_object_unref0 (_data_->_tmp18_);
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp52_ = stderr;
			_data_->_tmp53_ = _data_->e;
			_data_->_tmp54_ = _data_->_tmp53_->message;
			fprintf (_data_->_tmp52_, "Error: %s\n", _data_->_tmp54_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_g_object_unref0 (_data_->file);
	}
	_data_->_tmp55_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_data_->files = _data_->_tmp55_;
	_data_->items = 0;
	{
		_data_->_tmp56_ = _data_->self->priv->music_folders;
		_data_->_tmp57_ = _g_object_ref0 (_data_->_tmp56_);
		_data_->_folder_list = _data_->_tmp57_;
		_data_->_tmp58_ = _data_->_folder_list;
		_data_->_tmp59_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp58_);
		_data_->_tmp60_ = _data_->_tmp59_;
		_data_->_folder_size = _data_->_tmp60_;
		_data_->_folder_index = -1;
		while (TRUE) {
			_data_->_folder_index = _data_->_folder_index + 1;
			_data_->_tmp61_ = _data_->_folder_index;
			_data_->_tmp62_ = _data_->_folder_size;
			if (!(_data_->_tmp61_ < _data_->_tmp62_)) {
				break;
			}
			_data_->_tmp63_ = _data_->_folder_list;
			_data_->_tmp64_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp63_, _data_->_folder_index);
			_data_->_vala1_folder = (gchar*) _data_->_tmp64_;
			_data_->_tmp65_ = _data_->_vala1_folder;
			_data_->_tmp66_ = g_file_new_for_uri (_data_->_tmp65_);
			_data_->music_folder_file = _data_->_tmp66_;
			_data_->_tmp67_ = _data_->music_folder_file;
			_data_->_tmp68_ = _data_->files;
			_data_->items += music_file_utils_count_music_files (_data_->_tmp67_, (GeeCollection*) _data_->_tmp68_);
			_g_object_unref0 (_data_->music_folder_file);
			_g_free0 (_data_->_vala1_folder);
		}
		_g_object_unref0 (_data_->_folder_list);
	}
	g_debug ("AudioPlayerDevice.vala:92: found %d items to import\n", _data_->items);
	_data_->_tmp69_ = _data_->self->priv->library;
	_data_->_tmp70_ = _data_->_tmp69_->tagger;
	_data_->_tmp71_ = _data_->files;
	music_gstreamer_tagger_discoverer_import_media (_data_->_tmp70_, (GeeCollection*) _data_->_tmp71_);
	_data_->_tmp72_ = _data_->files;
	_data_->_tmp73_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp72_);
	_data_->_tmp74_ = _data_->_tmp73_;
	if (_data_->_tmp74_ == 0) {
		_data_->_tmp75_ = _data_->self->priv->library;
		music_plugins_audio_player_library_queue_finished (_data_->_tmp75_);
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, g_object_ref (_data_->self), g_object_unref);
	_g_object_unref0 (_data_->files);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static MusicLibrary*
music_plugins_audio_player_device_real_get_library (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	MusicPluginsAudioPlayerLibrary* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->library;
	_tmp1_ = _g_object_ref0 ((MusicLibrary*) _tmp0_);
	result = _tmp1_;
	return result;
}

static gchar*
music_plugins_audio_player_device_real_get_empty_device_title (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	_tmp0_ = g_strdup (_ ("Empty device!"));
	result = _tmp0_;
	return result;
}

static gchar*
music_plugins_audio_player_device_real_get_empty_device_description (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	_tmp0_ = g_strdup (_ ("This device does not contain any music."));
	result = _tmp0_;
	return result;
}

static gchar*
music_plugins_audio_player_device_real_get_content_type (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	if (self->priv->is_androphone) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("android");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("audioplayer");
		result = _tmp1_;
		return result;
	}
}

static gchar*
music_plugins_audio_player_device_real_get_display_name (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	if (self->priv->is_androphone) {
		GMount* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = self->priv->mount;
		_tmp1_ = g_mount_get_name (_tmp0_);
		result = _tmp1_;
		return result;
	} else {
		GFile* file = NULL;
		GMount* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		gchar* name = NULL;
		GMount* _tmp11_;
		gchar* _tmp12_;
		_tmp2_ = self->priv->mount;
		_tmp3_ = g_mount_get_root (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_file_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strconcat (_tmp6_, "/.is_audio_player", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_file_new_for_path (_tmp8_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		_g_free0 (_tmp6_);
		_g_object_unref0 (_tmp4_);
		file = _tmp10_;
		_tmp11_ = self->priv->mount;
		_tmp12_ = g_mount_get_name (_tmp11_);
		name = _tmp12_;
		{
			GFile* _tmp13_;
			_tmp13_ = file;
			if (g_file_query_exists (_tmp13_, NULL) == TRUE) {
				GFileInputStream* _tmp14_ = NULL;
				GFile* _tmp15_;
				GFileInputStream* _tmp16_;
				GDataInputStream* dis = NULL;
				GDataInputStream* _tmp17_;
				gchar* line = NULL;
				_tmp15_ = file;
				_tmp16_ = g_file_read (_tmp15_, NULL, &_inner_error0_);
				_tmp14_ = _tmp16_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp17_ = g_data_input_stream_new ((GInputStream*) _tmp14_);
				dis = _tmp17_;
				while (TRUE) {
					gchar* _tmp18_ = NULL;
					GDataInputStream* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					const gchar* _tmp22_;
					const gchar* _tmp23_;
					_tmp19_ = dis;
					_tmp20_ = g_data_input_stream_read_line (_tmp19_, NULL, NULL, &_inner_error0_);
					_tmp18_ = _tmp20_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_free0 (line);
						_g_object_unref0 (dis);
						_g_object_unref0 (_tmp14_);
						goto __catch0_g_error;
					}
					_tmp21_ = _tmp18_;
					_tmp18_ = NULL;
					_g_free0 (line);
					line = _tmp21_;
					_tmp22_ = line;
					if (!(_tmp22_ != NULL)) {
						_g_free0 (_tmp18_);
						break;
					}
					_tmp23_ = line;
					if (string_contains (_tmp23_, "name=")) {
						gchar* names_unparsed = NULL;
						const gchar* _tmp24_;
						gchar** _tmp25_;
						gchar** _tmp26_;
						gchar** _tmp27_;
						gint _tmp27__length1;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						const gchar* _tmp31_;
						gchar** _tmp32_;
						gchar** _tmp33_;
						_tmp24_ = line;
						_tmp26_ = _tmp25_ = g_strsplit (_tmp24_, "name=", 2);
						_tmp27_ = _tmp26_;
						_tmp27__length1 = _vala_array_length (_tmp25_);
						_tmp28_ = _tmp27_[1];
						_tmp29_ = g_strdup (_tmp28_);
						_tmp30_ = _tmp29_;
						_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
						names_unparsed = _tmp30_;
						_tmp31_ = names_unparsed;
						_tmp33_ = _tmp32_ = g_strsplit (_tmp31_, "\"", 0);
						{
							gchar** names_collection = NULL;
							gint names_collection_length1 = 0;
							gint _names_collection_size_ = 0;
							gint names_it = 0;
							names_collection = _tmp33_;
							names_collection_length1 = _vala_array_length (_tmp32_);
							for (names_it = 0; names_it < names_collection_length1; names_it = names_it + 1) {
								gchar* _tmp34_;
								gchar* names = NULL;
								_tmp34_ = g_strdup (names_collection[names_it]);
								names = _tmp34_;
								{
									gboolean _tmp35_ = FALSE;
									const gchar* _tmp36_;
									_tmp36_ = names;
									if (_tmp36_ != NULL) {
										const gchar* _tmp37_;
										_tmp37_ = names;
										_tmp35_ = g_strcmp0 (_tmp37_, "") != 0;
									} else {
										_tmp35_ = FALSE;
									}
									if (_tmp35_) {
										const gchar* _tmp38_;
										gchar* _tmp39_;
										_tmp38_ = names;
										_tmp39_ = g_strdup (_tmp38_);
										_g_free0 (name);
										name = _tmp39_;
									}
									_g_free0 (names);
								}
							}
							names_collection = (_vala_array_free (names_collection, names_collection_length1, (GDestroyNotify) g_free), NULL);
						}
						_g_free0 (names_unparsed);
					}
					_g_free0 (_tmp18_);
				}
				_g_free0 (line);
				_g_object_unref0 (dis);
				_g_object_unref0 (_tmp14_);
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			FILE* _tmp40_;
			GError* _tmp41_;
			const gchar* _tmp42_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp40_ = stderr;
			_tmp41_ = e;
			_tmp42_ = _tmp41_->message;
			fprintf (_tmp40_, "Error: %s\n", _tmp42_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (name);
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		result = name;
		_g_object_unref0 (file);
		return result;
	}
}

static void
music_plugins_audio_player_device_real_set_display_name (MusicDevice* base,
                                                         const gchar* name)
{
	MusicPluginsAudioPlayerDevice * self;
	self = (MusicPluginsAudioPlayerDevice*) base;
	g_return_if_fail (name != NULL);
}

static gchar*
music_plugins_audio_player_device_real_get_fancy_description (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	if (self->priv->is_androphone) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (_ ("Android Phone"));
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (_ ("Audio Player"));
		result = _tmp1_;
		return result;
	}
}

static void
music_plugins_audio_player_device_real_set_mount (MusicDevice* base,
                                                  GMount* mount)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	self = (MusicPluginsAudioPlayerDevice*) base;
	g_return_if_fail (mount != NULL);
	_tmp0_ = _g_object_ref0 (mount);
	_g_object_unref0 (self->priv->mount);
	self->priv->mount = _tmp0_;
}

static GMount*
music_plugins_audio_player_device_real_get_mount (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	GMount* _tmp1_;
	GMount* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->mount;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static gchar*
music_plugins_audio_player_device_real_get_uri (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->mount;
	_tmp1_ = g_mount_get_default_location (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_get_uri (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}

static void
music_plugins_audio_player_device_real_set_icon (MusicDevice* base,
                                                 GIcon* icon)
{
	MusicPluginsAudioPlayerDevice * self;
	GIcon* _tmp0_;
	self = (MusicPluginsAudioPlayerDevice*) base;
	g_return_if_fail (icon != NULL);
	_tmp0_ = _g_object_ref0 (icon);
	_g_object_unref0 (self->priv->icon);
	self->priv->icon = _tmp0_;
}

static GIcon*
music_plugins_audio_player_device_real_get_icon (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GIcon* _tmp0_;
	GIcon* _tmp1_;
	GIcon* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->icon;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static guint64
music_plugins_audio_player_device_real_get_capacity (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	rv = (guint64) 0;
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		_tmp0_ = music_device_get_uri ((MusicDevice*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_file_new_for_uri (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_g_free0 (_tmp1_);
		file_info = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
		_g_object_unref0 (file_info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = stdout;
		_tmp7_ = err;
		_tmp8_ = _tmp7_->message;
		fprintf (_tmp6_, "Error calculating capacity of iPod: %s\n", _tmp8_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		guint64 _tmp9_ = 0ULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp9_;
	}
	result = (guint64) rv;
	return result;
}

static gchar*
music_plugins_audio_player_device_real_get_fancy_capacity (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	_tmp0_ = g_format_size_full (music_device_get_capacity ((MusicDevice*) self), G_FORMAT_SIZE_DEFAULT);
	result = _tmp0_;
	return result;
}

static guint64
music_plugins_audio_player_device_real_get_used_space (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	result = music_device_get_capacity ((MusicDevice*) self) - music_device_get_free_space ((MusicDevice*) self);
	return result;
}

gchar*
music_plugins_audio_player_device_get_music_folder (MusicPluginsAudioPlayerDevice* self)
{
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->music_folders;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	result = (gchar*) _tmp1_;
	return result;
}

static guint64
music_plugins_audio_player_device_real_get_free_space (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	rv = (guint64) 0;
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		_tmp0_ = music_device_get_uri ((MusicDevice*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_file_new_for_uri (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_g_free0 (_tmp1_);
		file_info = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
		_g_object_unref0 (file_info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = stdout;
		_tmp7_ = err;
		_tmp8_ = _tmp7_->message;
		fprintf (_tmp6_, "Error calculating free space on iPod: %s\n", _tmp8_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		guint64 _tmp9_ = 0ULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp9_;
	}
	result = rv;
	return result;
}

static void
music_plugins_audio_player_device_real_unmount (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	self = (MusicPluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->mount;
	g_mount_unmount_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
}

static void
music_plugins_audio_player_device_real_eject (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
	self = (MusicPluginsAudioPlayerDevice*) base;
	_tmp0_ = self->priv->mount;
	if (g_mount_can_eject (_tmp0_)) {
		GMount* _tmp1_;
		GVolume* _tmp2_;
		GVolume* _tmp3_;
		GDrive* _tmp4_;
		GDrive* _tmp5_;
		_tmp1_ = self->priv->mount;
		_tmp2_ = g_mount_get_volume (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_volume_get_drive (_tmp3_);
		_tmp5_ = _tmp4_;
		g_drive_eject_with_operation (_tmp5_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
		_g_object_unref0 (_tmp5_);
		_g_object_unref0 (_tmp3_);
	}
}

static void
music_plugins_audio_player_device_real_synchronize (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	self = (MusicPluginsAudioPlayerDevice*) base;
}

static gboolean
music_plugins_audio_player_device_real_only_use_custom_view (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
	self = (MusicPluginsAudioPlayerDevice*) base;
	result = FALSE;
	return result;
}

static GtkWidget*
music_plugins_audio_player_device_real_get_custom_view (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	GtkWidget* result = NULL;
	self = (MusicPluginsAudioPlayerDevice*) base;
	result = NULL;
	return result;
}

static gboolean
music_plugins_audio_player_device_real_read_only (MusicDevice* base)
{
	MusicPluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
	self = (MusicPluginsAudioPlayerDevice*) base;
	result = FALSE;
	return result;
}

static void
music_plugins_audio_player_device_class_init (MusicPluginsAudioPlayerDeviceClass * klass,
                                              gpointer klass_data)
{
	music_plugins_audio_player_device_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPluginsAudioPlayerDevice_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_plugins_audio_player_device_finalize;
}

static void
music_plugins_audio_player_device_music_device_interface_init (MusicDeviceIface * iface,
                                                               gpointer iface_data)
{
	music_plugins_audio_player_device_music_device_parent_iface = g_type_interface_peek_parent (iface);
	iface->finish_initialization = (void (*) (MusicDevice*)) music_plugins_audio_player_device_real_finish_initialization;
	iface->start_initialization = (gboolean (*) (MusicDevice*)) music_plugins_audio_player_device_real_start_initialization;
	iface->get_library = (MusicLibrary* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_library;
	iface->get_empty_device_title = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_empty_device_title;
	iface->get_empty_device_description = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_empty_device_description;
	iface->get_content_type = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_content_type;
	iface->get_display_name = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_display_name;
	iface->set_display_name = (void (*) (MusicDevice*, const gchar*)) music_plugins_audio_player_device_real_set_display_name;
	iface->get_fancy_description = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_fancy_description;
	iface->set_mount = (void (*) (MusicDevice*, GMount*)) music_plugins_audio_player_device_real_set_mount;
	iface->get_mount = (GMount* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_mount;
	iface->get_uri = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_uri;
	iface->set_icon = (void (*) (MusicDevice*, GIcon*)) music_plugins_audio_player_device_real_set_icon;
	iface->get_icon = (GIcon* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_icon;
	iface->get_capacity = (guint64 (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_capacity;
	iface->get_fancy_capacity = (gchar* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_fancy_capacity;
	iface->get_used_space = (guint64 (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_used_space;
	iface->get_free_space = (guint64 (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_free_space;
	iface->unmount = (void (*) (MusicDevice*)) music_plugins_audio_player_device_real_unmount;
	iface->eject = (void (*) (MusicDevice*)) music_plugins_audio_player_device_real_eject;
	iface->synchronize = (void (*) (MusicDevice*)) music_plugins_audio_player_device_real_synchronize;
	iface->only_use_custom_view = (gboolean (*) (MusicDevice*)) music_plugins_audio_player_device_real_only_use_custom_view;
	iface->get_custom_view = (GtkWidget* (*) (MusicDevice*)) music_plugins_audio_player_device_real_get_custom_view;
	iface->read_only = (gboolean (*) (MusicDevice*)) music_plugins_audio_player_device_real_read_only;
}

static void
music_plugins_audio_player_device_instance_init (MusicPluginsAudioPlayerDevice * self,
                                                 gpointer klass)
{
	self->priv = music_plugins_audio_player_device_get_instance_private (self);
	self->priv->is_androphone = FALSE;
}

static void
music_plugins_audio_player_device_finalize (GObject * obj)
{
	MusicPluginsAudioPlayerDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, MusicPluginsAudioPlayerDevice);
	_g_object_unref0 (self->priv->mount);
	_g_object_unref0 (self->priv->icon);
	_g_object_unref0 (self->priv->music_folders);
	_g_object_unref0 (self->priv->library);
	G_OBJECT_CLASS (music_plugins_audio_player_device_parent_class)->finalize (obj);
}

GType
music_plugins_audio_player_device_get_type (void)
{
	return music_plugins_audio_player_device_type_id;
}

GType
music_plugins_audio_player_device_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsAudioPlayerDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_audio_player_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsAudioPlayerDevice), 0, (GInstanceInitFunc) music_plugins_audio_player_device_instance_init, NULL };
	static const GInterfaceInfo music_device_info = { (GInterfaceInitFunc) music_plugins_audio_player_device_music_device_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	music_plugins_audio_player_device_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsAudioPlayerDevice", &g_define_type_info, 0);
	g_type_module_add_interface (module, music_plugins_audio_player_device_type_id, MUSIC_TYPE_DEVICE, &music_device_info);
	MusicPluginsAudioPlayerDevice_private_offset = sizeof (MusicPluginsAudioPlayerDevicePrivate);
	return music_plugins_audio_player_device_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

